/* Generated by Together */
//Author Jrme Landgrfe
package pacman.character;

//jl
import java.util.*;
import java.io.*;
import jade.core.*;
import jade.lang.acl.*;
//mobility
import jade.domain.MobilityOntology;
import jade.lang.Codec;
import jade.lang.sl.SL0Codec;
//service description
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;
//
import pacman.character.PacManCharacter;
import pacman.character.PacManRequestBehaviour;
import pacman.data.RegisterCharacter;
import pacman.data.PlaygroundData;

public class Monster extends PacManCharacter {
  //transiente Variablen werden nicht serialisiert, d.h. bei der Migration nicht
  //uebertragen, sondern durch Erhalt des neuen Spielfeldes lokal neu erzeugt
   private transient ArrayList playground = null;
   private transient ArrayList heros = null;
   private transient ArrayList monsters = null;
   private ArrayList registeredGUIs = new ArrayList();
   private ArrayList registeredControllers = new ArrayList();
   private int direction;
   private int posX;
   private int posY;
   private transient GetAvailableLocationsBehaviour b1 = null;
   private transient GetAvailableLocationsBehaviour2 b2 = null;
   private transient int width,height;
   private transient boolean migrated=false;
   private transient Location l_source = null ,l_target = null;

   public void setup() {
      // create the agent description of itself
      try
      {
         ServiceDescription sd = new ServiceDescription();
         sd.setType( "Monster" );
         sd.setName( "Monster" );
         DFAgentDescription dfd = new DFAgentDescription();
         dfd.setName( getAID() );
         dfd.addServices( sd );
         // register the description with the DF
         DFService.register( this, dfd );
      }
      catch ( FIPAException e ) { e.printStackTrace(); }
      initMonster();
      // register the SL0 content language
      registerLanguage(SL0Codec.NAME, new SL0Codec());
      // register the mobility ontology
      registerOntology(MobilityOntology.NAME, MobilityOntology.instance());
      //merk Dir den Container des aktuellen Spielfeldes
      b1 = new GetAvailableLocationsBehaviour(this, playgroundName);
      addBehaviour(b1);
      super.setup();
   }

   public void step() {
      //jl
      playground = getPlayground();
      posX = getPosX();
      heros = getHeros();
      posY = getPosY();
      monsters = getMonsters();
      //jle
      //Autopilot
      if(playground!=null){
         if (auto) {
            //erkunde eigene Position und Direction
            Iterator i = heros.iterator();
            pacman.data.MonsterData h;
            while (i.hasNext()) {
               h = (pacman.data.MonsterData) i.next();
               if (h.getName().equals(this.getName())) {
                  posX = h.getX();
                  posY = h.getY();
                  if(!migrated){
                     direction = getDirection();
                     String dir = h.getDirection();
                     System.out.println("Direction from field: "+dir);
                     if (dir.equals("N")) direction = NORTH;
                     else if (dir.equals("S")) direction = SOUTH;
                     else if (dir.equals("W")) direction = WEST;
                     else if (dir.equals("E")) direction = EAST;
                     //Ueberpruefe, ob Agent weiter in die alte Richtung laufen kann
                     int tmpX=posX;
                     int tmpY=posY;
                     System.out.println("dir from field "+direction+"tmpX:"+tmpX+" tmpY:"+tmpY);
                     if (direction < 0 || direction > 3) {
                        //jl
                        System.out.println("d0" +direction);
                        move(searchForNewDirection(direction, false));
                        //jle
                        return;
                     }
                     if (direction == PacManCharacter.NORTH) tmpY--;
                     if (direction == PacManCharacter.SOUTH) tmpY++;
                     if (direction == PacManCharacter.WEST) tmpX--;
                     if (direction == PacManCharacter.EAST) tmpX++;
                     System.out.println("direction "+direction+" tmpX:"+tmpX+" tmpY:"+tmpY);
                     //hier Ursache fuer IndexoutOfBounds
                     int maxY=((ArrayList)playground).size();
                     int maxX=((ArrayList)(playground.get(0))).size();
                     if(tmpX<maxX&tmpY<maxY&tmpX>=0&tmpY>=0){
                        String content = (String)((ArrayList)playground.get(tmpY)).get(tmpX);
                        System.out.println("c1 " +content);
                        if (content.equals("S")
                              || content.equals("C")
                              || content.equals("P")|| content.equals("M")) {
                           //pruefe auch, ob eine Weggabelung vorliegt, entscheide auch dann neu...
                           if (direction == PacManCharacter.NORTH || direction == PacManCharacter.SOUTH) {
                              String content_west = (String)((ArrayList)playground.get(tmpY)).get(tmpX - 1);
                              String content_east = (String)((ArrayList)playground.get(tmpY)).get(tmpX + 1);
                              System.out.println("No "+content_west+" "+content_east);
                              if (content_west.equals("C")
                                    || content_west.equals("P")
                                    || content_west.equals("S")
                                    || content_west.equals("M")
                                    || content_east.equals("C")
                                    || content_east.equals("P")
                                    || content_east.equals("S")
                                    || content_east.equals("M")) {
                                 //es liegt eine Weggabelung vor
                                 System.out.println("Gabelung");
                                 System.out.println(direction);
                                 direction = searchForNewDirection(direction,
                                                                   true);
                                 System.out.println("d3 " +direction);
                                 move(direction);
                              }
                           }
                           else if (direction == PacManCharacter.WEST
                                 || direction == PacManCharacter.EAST) {
                              String content_north = (String)((ArrayList)playground.get(tmpY - 1)).get(tmpX);
                              String content_south = (String)((ArrayList)playground.get(tmpY + 1)).get(tmpX);
                              System.out.println("We "+content_north+" "+content_south);
                              if (content_north.equals("C")
                                    || content_north.equals("P")
                                    || content_north.equals("S")
                                    || content_north.equals("M")
                                    ||content_south.equals("C")
                                    || content_south.equals("P")
                                    || content_south.equals("S")
                                    || content_south.equals("M")) {
                                 //es liegt eine Weggabelung vor
                                 //jl
                                 System.out.println("Gabelung");
                                 System.out.println(direction);
                                 direction = searchForNewDirection(direction,
                                                                   true);
                                 System.out.println("d4 " +direction);
                                 //jle
                                 move(direction);
                              }
                           }
                        }
                        else {
                           //suche neuen Weg
                           //jl
                           System.out.println("Else "+content);
                           System.out.println(direction);
                           direction = searchForNewDirection(direction, false);
                           System.out.println("d5 " +direction);
                           //jle
                           move(direction);
                        }
                     }//Ende if(!migrated)
                  }else{
                     migrated=false;
                     width=playground.size()-1;
                     height=((ArrayList)playground.get(0)).size()-1;
                     if(posY==0){
                        direction=SOUTH;
                     }else if(posY==height){
                        direction=NORTH;
                     }else if(posX==0){
                        direction=EAST;
                     }else if(posX==width){
                        direction=WEST;
                     }
                     System.out.println("aftermove "+posX+" "+posY+" dir:"+direction);
                     System.out.println("direction after migration:"+direction+" posX "+posX+" posY "+posY);
                     move(direction);
                     //doWait(1500);
                  }
               }
            }
         }else{//end if (auto)
            move(manualdirection);
         }
      }
   }

   protected int searchForNewDirection(int current_direction,
                                       boolean isCrossRoads) {
      int value = 9;
      System.out.println("beg search dir" +current_direction);
      //Korrektur fuer evtl. falsche isCrossRoads-Belegung:
      int tmpX = posX;
      int tmpY = posY;
      System.out.println("hero posX:"+posX+ "character:"+getPosX()+"hero posY:"+posY+ "character:"+getPosY());
      if (direction == PacManCharacter.NORTH) tmpY--;
      if (direction == PacManCharacter.SOUTH) tmpY++;
      if (direction == PacManCharacter.WEST) tmpX--;
      if (direction == PacManCharacter.EAST) tmpX++;
      //gegen IndexOutOfBounds bei Migration
      int maxY=((ArrayList)playground).size();
      int maxX=((ArrayList)(playground.get(0))).size();
      if(tmpX<maxX&tmpY<maxY&tmpX>=0&tmpY>=0){
         String content = (String)((ArrayList)playground.get(tmpY)).get(tmpX);
         if (content.equals("W")) {
            System.out.println("Korrektur");
            isCrossRoads = false;
         }
         //07.07: rueckwaerts gehen fuer Testfelder wieder aktiviert
         int back_dir;
         switch (current_direction) {
         case 0:
            back_dir = 1;
            break;
         case 1:
            back_dir = 0;
            break;
         case 2:
            back_dir = 3;
            break;
         case 3:
            back_dir = 2;
            break;
         default:
            back_dir = -1;
         }
         System.out.println("curr"+direction+" back "+back_dir);
         Random rnd = new Random();
         boolean free = false;
         int myX = 0;
         int myY = 0;
         while (!free) {
            value = rnd.nextInt(4);
            tmpX = posX;
            tmpY = posY;
            //jl
            System.out.println(value);
            //07.07 rueckwaerts gehen fuer Testfelder wieder aktiviert
            if (/*value != back_dir*/true) {
               System.out.println("tmpx/y "+tmpX+" "+tmpY);
               if (isCrossRoads) {
                  if (value == PacManCharacter.SOUTH & direction == PacManCharacter.WEST) {
                     tmpY++;
                     tmpX--;
                     System.out.println("crossr sw "+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.NORTH & direction == PacManCharacter.WEST) {
                     tmpY--;
                     tmpX--;
                     System.out.println("crossr nw"+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.SOUTH & direction == PacManCharacter.EAST) {
                     tmpY++;
                     tmpX++;
                     System.out.println("crossr se"+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.NORTH & direction == PacManCharacter.EAST) {
                     tmpY--;
                     tmpX++;
                     System.out.println("crossr ne"+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.WEST & direction == PacManCharacter.NORTH) {
                     tmpX--;
                     System.out.println("crossr wn"+tmpX+" "+tmpY);
                     tmpY--;
                  }
                  else if (value == PacManCharacter.EAST & direction == PacManCharacter.NORTH) {
                     tmpX++;
                     tmpY--;
                     System.out.println("crossr en"+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.WEST & direction == PacManCharacter.SOUTH) {
                     tmpX--;
                     tmpY++;
                     System.out.println("crossr ws"+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.EAST & direction == PacManCharacter.SOUTH) {
                     tmpX++;
                     tmpY++;
                     System.out.println("crossr es"+tmpX+" "+tmpY);
                  }
                  else if (value == PacManCharacter.NORTH) tmpY--;
                  else if (value == PacManCharacter.SOUTH) tmpY++;
                  else if (value == PacManCharacter.WEST) tmpX--;
                  else if (value == PacManCharacter.EAST) tmpX++;
                  System.out.println("else1 crossr "+tmpX+" "+tmpY);
               } else {
                  if (value == PacManCharacter.NORTH) tmpY--;
                  if (value == PacManCharacter.SOUTH) tmpY++;
                  if (value == PacManCharacter.WEST) tmpX--;
                  if (value == PacManCharacter.EAST) tmpX++;
                  System.out.println("else2 crossr "+tmpX+" "+tmpY);
               }
               //07.07 gg. IndexOutOfBounds bei Migration
               if(tmpX<maxX&tmpY<maxY&tmpX>=0&tmpY>=0){
                  content = (String)((ArrayList)playground.get(tmpY)).get(tmpX);
                  if (content.equals("C")
                        || content.equals("P")
                        || content.equals("S")|| content.equals("M")) {
                     free = true;
                     System.out.println("ret val "+value);
                  }
                  System.out.println("cont val "+value);
               }else{//7.7. damit man bei OutOfBound nicht haengen bleibt
                  free=true;
               }
            }
         }
      }
      return value;
   }

   //mobility
   protected void beforeMove() {
      //jl: Spielfeld muss diese Nachricht behandeln
      System.out.println("deregister "+playgroundName);
      deregisterCharacterFromPlayground();
      System.out.println("beforeMove");
      playgroundName=newplaygroundName;
      deregisterCharacterFromGUI();
   }

   protected void afterMove() {
      migrated=true;
      System.out.println("afterMove: "+newplaygroundName);
      registerLanguage(SL0Codec.NAME, new SL0Codec());
      registerOntology(MobilityOntology.NAME, MobilityOntology.instance());
      //jl: Spielfeld muss diese Nachricht behandeln
      playgroundName=newplaygroundName;
      registerCharacterToPlayground(playgroundName,
                                    RegisterCharacter.MONSTER,startKoord);
      System.out.println("Setting agent position on"+playgroundName+" after moving to"+startKoord.getX()+","+startKoord.getY());
      posX=startKoord.getX();
      posY=startKoord.getY();
      //merk Dir den Container des aktuellen Spielfeldes
      b1 = new GetAvailableLocationsBehaviour(this, playgroundName);
      addBehaviour(b1);
   }

   public void moveToField(String target) {
      newplaygroundName = target;
      System.out.println("pg:"+playgroundName+" np:"+newplaygroundName);
      b2 = new GetAvailableLocationsBehaviour2(this, newplaygroundName);
      addBehaviour(b2);
      System.out.println("end wait 2");
   }

   public void saveLocationTarget(Iterator i) {
      System.out.println("target1");
      while (i.hasNext()) {
         System.out.println("target2");
         Location l = (Location)(i.next());
         l_target=l;
         System.out.println("target "+l_target.getName());
      }
      System.out.println("target3");
      testMoving();
   }

   public void saveLocationSource(Iterator i) {
      while (i.hasNext()) {
         Location l = (Location)(i.next());
         l_source=l;
         System.out.println("source "+l_source.getName());
      }
   }

   public void testMoving() {
      //workaround, falls ein behaviour nicht zurueckkehrt, versuche die suche noch einmal
      while(l_target==null
            ||l_source==null){
         System.out.println("retrying behaviours with "+playgroundName+","+newplaygroundName);
         if(l_target==null){
            removeBehaviour(b2);
            b2 = new GetAvailableLocationsBehaviour2(this, newplaygroundName);
            addBehaviour(b2);
            doWait(2000);
         }
         if(l_source==null){
            removeBehaviour(b1);
            b1 = new GetAvailableLocationsBehaviour(this, playgroundName);
            addBehaviour(b1);
            doWait(2000);
         }
      }
      if((!(l_target.getName().equals(l_source.getName())))){
         System.out.println("moving to container "+l_target.getName());
         removeBehaviour(b2);
         removeBehaviour(b1);
         doMove(l_target);
      }else {
         System.out.println("migriere nicht, sondern wechsele nur die Position");
         deregisterCharacterFromGUI();
         deregisterCharacterFromPlayground();
         startKoord = getStartKoord();
         registerCharacterToPlayground(playgroundName,
                                       RegisterCharacter.MONSTER,startKoord);
      }
   }

   public void printLocations(Iterator i) {
      while (i.hasNext()) {
         Location l = (Location)(i.next());
         System.out.println("Adress " + l.getAddress());
         System.out.println("Name " + l.getName());
      }
   }

   public void initMonster() {
      initPacManCharacter(RegisterCharacter.MONSTER);
   }

   protected void decreaseLife() {
      remainingLifes--;
      if (remainingLifes > 0) {
         initMonster();
      }
      else {
         characterDied();
      }
   }

   private String target;
}
