package pacman.character;

import jade.core.Agent;
import java.util.*;
import java.io.*;
import jade.core.*;
import jade.lang.acl.*;
import java.awt.geom.Point2D;
import pacman.data.RegisterCharacter;
import pacman.data.PlaygroundData;
import pacman.data.Koordinate;
//service description
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;
//
//mobility
import jade.domain.MobilityOntology;
import jade.lang.Codec;
import jade.lang.sl.SL0Codec;

//
abstract class PacManCharacter extends Agent {
   private ArrayList playground;
   private ArrayList heros;
   private ArrayList monsters;
   //jl
   private ArrayList registeredGUIs= new ArrayList();
   private ArrayList registeredControllers = new ArrayList();
//   protected ArrayList registeredGUIs= new ArrayList();
//   protected ArrayList registeredControllers = new ArrayList();
   //jle
   protected int posX;
   protected int posY;
   protected int direction;
   //jl
   protected static final int NORTH = 0;
   protected static final int SOUTH = 1;
   protected static final int WEST = 2;
   protected static final int EAST = 3;
   //jle
   private int typeName;
   protected boolean auto = true;
   //bei bernahme der manuellen Steuerung Held zunchst anhalten...
   protected int manualdirection=-1;
   protected Koordinate startKoord;
   protected String playgroundName,newplaygroundName;
   protected int remainingLifes = 3;
   protected int points = 0;
   //mobility
   private Location l_source = null ,l_target = null;

   public void setup() {
      // register the SL0 content language
      registerLanguage(SL0Codec.NAME, new SL0Codec());
      // register the mobility ontology
      registerOntology(MobilityOntology.NAME, MobilityOntology.instance());
      addBehaviour(new PacManRequestBehaviour(this));
   }

   public void initPacManCharacter(int type) {
      Object[] obj = this.getArguments();
      playgroundName = "";
      if (obj.length >= 1) {
         playgroundName = (String)obj[0];
         typeName = type;
         direction=-1;
         registerCharacterToPlayground(playgroundName, typeName, null);
         System.out.println("registered at: " + playgroundName);
      }
      else {
         System.out.println("no Playground available");
         doDelete();
      }
   }

   public void step() {
      //Autopilot
      if (auto) {
         //erkunde eigene Position und Direction
         Iterator i = heros.iterator();
         pacman.data.HeroData h;
         while (i.hasNext()) {
            h = (pacman.data.HeroData) i.next();
            if (h.getName().equals(this.getName())) {
               posX = h.getX();
               posY = h.getY();
               String dir = h.getDirection();
               System.out.println("Direction from field: " + dir);
               if (dir.equals("N")) direction = NORTH;
               else if (dir.equals("S")) direction = SOUTH;
               else if (dir.equals("W")) direction = WEST;
               else if (dir.equals("E")) direction = EAST;
            }
         }
         //?berpr?fe, ob Agent weiter in die alte Richtung laufen kann
         int tmpX = posX;
         int tmpY = posY;
         if (direction < 0 || direction > 3) {
            //jl
            move(searchForNewDirection(direction));
            //jle
            return;
         }
         if (direction == PacManCharacter.NORTH) tmpY--;
         if (direction == PacManCharacter.SOUTH) tmpY++;
         if (direction == PacManCharacter.WEST) tmpX--;
         if (direction == PacManCharacter.EAST) tmpX++;
         String content = (String)((ArrayList)playground.get(tmpY)).get(tmpX);
         if (content.equals("C")
               || content.equals("P") || content.equals("S")) {
            //alles in Ordnung, n?chster Zug kann abgewartet werden
         }
         else {
            //suche neuen Weg
            //jl
            direction = searchForNewDirection(direction);
            //jle
            move(direction);
         }
      }
   }

   //jl
   protected int searchForNewDirection(int current_direction) {
      //jl
      //nicht r?ckw?rts gehen. Dies setz aber voraus, da? es im Spielfeld keine Sackgassen gibt,
      //aus denen man nur r?ckw?rts hinauskommt
      int back_dir;
      switch (current_direction) {
      case 0:
         back_dir = 1;
         break;
      case 1:
         back_dir = 0;
         break;
      case 2:
         back_dir = 3;
         break;
      case 3:
         back_dir = 2;
         break;
      default:
         back_dir = -1;
      }
      //jle
      Random rnd = new Random();
      boolean free = false;
      int value = 9;
      while (!free) {
         value = rnd.nextInt(4);
         //jl
         if (value != back_dir) {
            int tmpX = posX;
            int tmpY = posY;
            if (value == PacManCharacter.NORTH) tmpY--;
            if (value == PacManCharacter.SOUTH) tmpY++;
            if (value == PacManCharacter.WEST) tmpX--;
            if (value == PacManCharacter.EAST) tmpX++;
            String content = (String)((ArrayList)playground.get(tmpY)).get(tmpX);
            if (content.equals("C")
                  || content.equals("P") || content.equals("S"))
               free = true;
         }
         //jle
      }
      return value;
   }

   //jle
   public void move(int direction) {
      try {
         ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
         AID aid = new AID();
         aid.setName(playgroundName);
         msg.addReceiver(aid);
         switch (direction) {
         case NORTH: { msg.setContent("N"); };
            break;
         case SOUTH: { msg.setContent("S"); };
            break;
         case WEST: { msg.setContent("W"); };
            break;
         case EAST: { msg.setContent("E"); };
            break;
         case -1: {msg.setContent("");}
            break;
         }
         msg.setLanguage("setDirection");
         send(msg);
         System.out.println("send " + direction);
      }
      catch (Exception e) {
         e.printStackTrace();
      }
   }

   //jl
   //jl
   //mobility
   public void printLocations(Iterator i) {
      while (i.hasNext()) {
         Location l = (Location)(i.next());
         System.out.println("Adress " + l.getAddress());
         System.out.println("Name " + l.getName());
      }
   }

/*   public void testMoving() {
    if((!(l_target.getName().equals(l_source.getName())))){
     doMove(l_target);
     }else{
      System.out.println("migriere nicht, sondern wechsele nur die Position");
     }
   }*/

   //jle
   //Methoden fuer GUI, die an einen Character registriert ist, und von Aenderungen informiert werden moechte
   protected void notifyGUIOfDeath() {
      registeredGUIs=getRegistedGUIs();
      if(registeredGUIs!=null&&registeredGUIs.size()>0){
         try {
            ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
            AID aid = new AID();
            for (int i = 0; i < registeredGUIs.size(); i++) {
               aid.setName((String)(registeredGUIs.get(i)));
               msg.addReceiver(aid);
               //msg.setContent(getLocalName());
               msg.setContent(getName());
               msg.setLanguage("notifyGUIOfDeath");
               send(msg);
            }
         }
         catch (Exception e) {
            e.printStackTrace();
         }
      }
   }

   protected void notifyGUIOfChangedField(String target) {
      registeredGUIs=getRegistedGUIs();
      if(registeredGUIs!=null&&registeredGUIs.size()>0){
         try {
            ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
            AID aid = new AID();
            for (int i = 0; i < registeredGUIs.size(); i++) {
               aid.setName((String)(registeredGUIs.get(i)));
               msg.addReceiver(aid);
               msg.setContent(target);
               msg.setLanguage("notifyGUIOfChangedField");
               send(msg);
            }
         }
         catch (Exception e) {
            e.printStackTrace();
         }
      }
   }
   //jle
   public void registerCharacterToPlayground(String target,
                                             int type, Koordinate k) {
      RegisterCharacter regChar = new RegisterCharacter(getName(), type, k);
      ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
      AID r = new AID();
      r.setName(target);
      msg.addReceiver(r);
      msg.setLanguage("registerCharacterToPlayground");
      try {
         msg.setContentObject(regChar);
      }
      catch (IOException ioe) {
         ioe.printStackTrace();
      }
      send(msg);
   }

   public void setPlaygroundContent(PlaygroundData playgroundData) {
      playground = playgroundData.getPlayground();
      heros = playgroundData.getHeros();
      monsters = playgroundData.getMonster();
   }

   public void addController(String controller) {
      registeredControllers.add(controller);
   }

   public void removeController(String controller) {
      registeredControllers.remove(controller);
   }

   //jl
   public void addGUI(String name) {
      System.out.println("add GUI " + name);
      registeredGUIs.add(name);
   }

   public void removeGUI(String name) {
      System.out.println("remove GUI " + name);
      registeredGUIs.remove(name);
   }

   protected void setAuto(boolean b) {
      auto = b;
   }

   protected void setDirection(String dir) {
      if(dir.equals("n"))
      manualdirection=NORTH;
      else if(dir.equals("s"))
      manualdirection=SOUTH;
      else if(dir.equals("w"))
      manualdirection=WEST;
      else if(dir.equals("e"))
      manualdirection=EAST;
      System.out.println("Received manual direction: "+manualdirection);
   }

   public ArrayList getPlayground() {
      return playground;
   }

   public ArrayList getHeros() {
      return heros;
   }

   public ArrayList getMonsters() {
      return monsters;
   }

   public ArrayList getRegistedGUIs() {
      return registeredGUIs;
   }

   public ArrayList getRegistedControllers() {
      return registeredControllers;
   }

   public int getDirection() {
      return direction;
   }

   public int getPosX() {
      return posX;
   }

   public int getPosY() {
      return posY;
   }

   public void setStartKoord(Koordinate k){
      startKoord=k;
   }

   public Koordinate getStartKoord(){
      return startKoord;
   }

  public Location getLocSource(){
      return l_source;
   }

   public Location getLocTarget(){
      return l_target;
   }
   protected void takeDown() {
      System.out.println("kill signal received...");
      System.out.println("cleaning up...");
      deregisterCharacterFromGUI();
      deregisterCharacterFromPlayground();
      //DF informieren, dass der Character verschwindet
      try {
        DFService.deregister(this);
      }catch (FIPAException e) {
            e.printStackTrace();
      }
      super.doDelete();
   }

   //  erhoeht die Punktzahl des Characters, evtl. haben auch Monster Punkte, wenn sie einen Helden
   //erlegen....
   //jl
   protected void addPoints(int n) {
      points = points + n;
      System.out.println("add Points "+points );
      notifyGUIOfPoints(points);
   }

   protected void characterDied() {
      notifyGUIOfDeath();
   }

   /*   protected void notifyGUIOfDeath() {
         registeredGUIs=getRegistedGUIs();
         if(registeredGUIs!=null){
            for(int i=0;i<registeredGUIs.size();i++){
               try {
                  ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
                  AID aid = new AID();
                  aid.setLocalName((String)(registeredGUIs.get(i)));
                  msg.addReceiver(aid);
                  msg.setLanguage("characterDied");
                  send(msg);
               }
               catch (Exception e) {
                  e.printStackTrace();
               }
            }
         }
      }
   */
   protected void notifyGUIOfPoints(int points) {
      registeredGUIs=getRegistedGUIs();
      if(registeredGUIs!=null&&registeredGUIs.size()>0){
         for(int i=0;i<registeredGUIs.size();i++){
           if(registeredGUIs.get(i)!=null&&!(registeredGUIs.get(i).equals(""))){
            try {
               ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
               AID aid = new AID();
               //aid.setLocalName((String)(registeredGUIs.get(i)));
               aid.setName((String)(registeredGUIs.get(i)));
               msg.addReceiver(aid);
               msg.setContent(Integer.toString(points));
               msg.setLanguage("givePoints");
               send(msg);
            }
            catch (Exception e) {
               e.printStackTrace();
            }
            }
         }
      }
   }

   protected void notifyGUIOfLifes(int lifes) {
      registeredGUIs=getRegistedGUIs();
      if(registeredGUIs!=null&&registeredGUIs.size()>0){
         for(int i=0;i<registeredGUIs.size();i++){
         if(registeredGUIs.get(i)!=null&&!(registeredGUIs.get(i).equals(""))){
            try {
               ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
               AID aid = new AID();
               //aid.setLocalName((String)(registeredGUIs.get(i)));
               aid.setName((String)(registeredGUIs.get(i)));
               msg.addReceiver(aid);
               msg.setContent(Integer.toString(lifes));
               msg.setLanguage("giveLifes");
               send(msg);
            }
            catch (Exception e) {
               e.printStackTrace();
            }
            }
         }
      }
   }

   protected void deregisterCharacterFromGUI() {
      registeredGUIs=getRegistedGUIs();
      if(registeredGUIs!=null&&registeredGUIs.size()>0){
            for (int i = 0; i < registeredGUIs.size(); i++) {
            if(registeredGUIs.get(i)!=null&&!(registeredGUIs.get(i).equals(""))){
            try {
               ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
               AID aid = new AID();
               aid.setName((String)(registeredGUIs.get(i)));
               msg.addReceiver(aid);
               //msg.setContent(getLocalName());
               msg.setContent(getName());
               msg.setLanguage("deregisterCharacterFromGUI");
               send(msg);
               }
            catch (Exception e) {
              e.printStackTrace();
              }
              }
            }
         }
   }

   protected void deregisterCharacterFromPlayground() {
      try {
         ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
         AID aid = new AID();
         //if (playground != null) {
         //   for (int i = 0; i < playground.size(); i++) {
               aid.setName(playgroundName);
               msg.addReceiver(aid);
               //msg.setContent(getLocalName());
               msg.setContent(getName());
               msg.setLanguage("deregisterCharacterFromPlayground");
               send(msg);
         //   }
         //}
      }
      catch (Exception e) {
         e.printStackTrace();
      }
   }
   //jle
}
