package pacman.character;

import pacman.data.PlaygroundData;
import pacman.data.MoveData;
import pacman.data.Koordinate;
import jade.core.behaviours.*;
import jade.core.*;
import jade.lang.acl.*;

public class PacManRequestBehaviour extends SimpleBehaviour {
   public PacManRequestBehaviour(Agent parent) {
      super(parent);
   }

   public void action() {
      System.out.println("message?");
      ACLMessage msg;
      // receive a new message
      msg = myAgent.receive();
      if (msg == null) {
         block();
         return;
      }
      if (msg.getLanguage().equals("PlaygroundContent")) {
         try {
            System.out.println("Nachricht erhalten (Spielfeld)");
            ((PacManCharacter)myAgent).setPlaygroundContent((PlaygroundData)(msg.getContentObject()));
            ((PacManCharacter)myAgent).step();
         }
         catch (Exception e) {
            e.printStackTrace();
         }
      }
      else if (msg.getLanguage().equals("decreaseLife"))
         {if(myAgent instanceof Hero)
         ((Hero)myAgent).decreaseLife();
         }
      else if (msg.getLanguage().equals("addCreditPoint"))
         {if(myAgent instanceof Hero)
         ((Hero)myAgent).addPoints(10);}
      else if (msg.getLanguage().equals("registerGUIToCharacter")) {
         String name = msg.getSender().getName();
         ((PacManCharacter)myAgent).addGUI(name);
      }
      else if (msg.getLanguage().equals("deregisterGUIFromCharacter")) {
         String name = msg.getSender().getName();
         ((PacManCharacter)myAgent).removeGUI(name);
      }
      else if (msg.getLanguage().equals("moveToNewField")) {
         String target = "";
         Koordinate koord = null;
         int x = 0 ,y = 0;
         try{
            MoveData md = (MoveData)msg.getContentObject();
            target = md.getName();
            koord = md.getKoordinate();
            x = koord.getX();
            y = koord.getY();
         }catch(UnreadableException ure){
            ure.printStackTrace();
         }
         System.out.println("Moving to "+target+" at "+x+","+y);
         if(myAgent instanceof Hero){
          ((Hero)myAgent).setStartKoord(koord);
          ((Hero)myAgent).moveToField(target);}else{
          ((Monster)myAgent).setStartKoord(koord);
          ((Monster)myAgent).moveToField(target);
         }
      }
      else if (msg.getLanguage().equals("connectControllerToPacManCharacter")) {
         String controller = msg.getSender().getLocalName();
         System.out.println("connect Controller " + controller);
         ((PacManCharacter)myAgent).addController(controller);
         ((PacManCharacter)myAgent).setAuto(false);
      }
      else if (msg.getLanguage().equals("disconnectControllerFromPacManCharacter")) {
         String controller = msg.getSender().getLocalName();
         System.out.println("disconnect Controller " + controller);
         ((PacManCharacter)myAgent).removeController(controller);
         ((PacManCharacter)myAgent).setAuto(true);
      }
      else if (msg.getLanguage().equals("setDirection")) {
         String direction = (String) msg.getContent();
         System.out.println("Received direction from Controller " + direction);
         ((PacManCharacter)myAgent).setDirection(direction);
      }
   }

   public boolean done() {
      return false;
   }
}
