/* Generated by Together */

package pacman.control;

import javax.swing.JDialog;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import pacman.data.PlaygroundData;
import pacman.data.PlaygroundCollection;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import pacman.data.ExitData;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import jade.core.Agent;
import jade.lang.acl.ACLMessage;
import jade.core.AID;
import pacman.data.ConnectExit;
import java.io.IOException;
import pacman.data.Koordinate;

public class ConnectDialog extends JDialog {
    private JLabel nameLabel = new JLabel();
    private JLabel koordLabel = new JLabel();
    private JComboBox nameComboBox = new JComboBox();
    private JComboBox koordComboBox = new JComboBox();
    private JButton changeButton = new JButton();
    private String nameFirst;
    private Agent agent;
    private Koordinate sourceKoord;

    /** Creates new form JDialog */
    public ConnectDialog(Frame parent, boolean modal, String nameFirst, Koordinate koord, Agent agent) {
        super(parent, modal);
        this.nameFirst = nameFirst;
        this.sourceKoord = koord;
        this.agent = agent;
        initGUI();
    }

    /** This method is called from within the constructor to initialize the form. */
    private void initGUI() {
        addWindowListener(
            new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent evt) {
                    closeDialog();
                }
            });
        pack();
        //fge die Informationen in die beiden Textfelder
        nameLabel.setText("Playground Name: " + nameFirst);
        koordLabel.setText("Koordinaten: (X:" + sourceKoord.getX() + " Y:" + sourceKoord.getY() + ")");
        //ermittle die Informationen fr die nameComboBox
        nameComboBox.addItem("not connected");
        for (int i = 0; i < DataManager.getInstance().getPlaygroundCollection().getPlaygroundCount(); i++) {
            nameComboBox.addItem(DataManager.getInstance().getPlaygroundCollection().getPlaygroundAt(i).getName().getName());
        }
        //disable die zweite ComboBox
        koordComboBox.setEnabled(false);
        nameComboBox.addItemListener(
            new ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    System.out.println("Item ausgewhlt");
                    String name = (String)e.getItem();
                    if (name.equals("not connected")) {
                        koordComboBox.setEnabled(false);
                        koordComboBox.removeAllItems();
                        return;
                    }
                    else {
                        koordComboBox.setEnabled(true);
                        PlaygroundData tmpPD;
                        for (int i = 0; i < DataManager.getInstance().getPlaygroundCollection().getPlaygroundCount(); i++) {
                            tmpPD = DataManager.getInstance().getPlaygroundCollection().getPlaygroundAt(i);
                            if (tmpPD.getName().getName().equals(name)) {
                                ExitData ed;
                                koordComboBox.removeAllItems();
                                for (int j = 0; j < tmpPD.getExitCount(); j++) {
                                    ed = tmpPD.getExit(j);
                                    if (!ed.isConnected()) koordComboBox.addItem(ed.getKoordinate());
                                }
                            }
                        }
                    }
                }
            });
        getContentPane().setLayout(new java.awt.GridLayout(5, 0));
        getContentPane().add(nameLabel);
        getContentPane().add(koordLabel);
        getContentPane().add(nameComboBox);
        getContentPane().add(koordComboBox);
        getContentPane().add(changeButton);
        changeButton.setLabel("Set Connection");
        changeButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    try {
                        Koordinate koord = (Koordinate)koordComboBox.getSelectedItem();
                        //erste Nachricht abschicken
                        ConnectExit ce = new ConnectExit(sourceKoord, (String)nameComboBox.getSelectedItem(), koord);
                        ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
                        AID aid = new AID();
                        aid.setName(nameFirst);
                        reply.addReceiver(aid);
                        reply.setLanguage("connectWith");
                        reply.setContentObject(ce);
                        agent.send(reply);
                        //zweite Nachricht
                        ce = new ConnectExit(koord, nameFirst, sourceKoord);
                        reply = new ACLMessage(ACLMessage.INFORM);
                        aid = new AID();
                        aid.setName((String)nameComboBox.getSelectedItem());
                        reply.addReceiver(aid);
                        reply.setLanguage("connectWith");
                        reply.setContentObject(ce);
                        agent.send(reply);
                        closeDialog();
                    }
                    catch (IOException f) {
                        f.printStackTrace();
                    }
                }
            });
    }

    /** Closes the dialog */
    private void closeDialog() {
        setVisible(false);
        dispose();
    }
}
