/* Generated by Together */

package pacman.control;

import jade.gui.GuiAgent;
import java.awt.Dimension;
import java.awt.Toolkit;
import jade.gui.GuiEvent;
import jade.core.behaviours.SimpleBehaviour;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;
import pacman.data.PlaygroundCollection;
import pacman.data.PlaygroundData;
import jade.lang.acl.ACLMessage;
import jade.core.AID;
import jade.core.behaviours.WakerBehaviour;

public class ControlAgent extends GuiAgent {
    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     */
    private ControlGUI lnkControlGUI;
    private String name = "Control Agent Version 0.9";
    public static final int EXIT_EVENT = 0;

    public void setup() {
        name += " (AgentName: " + this.getAID().getName() + " )";
        lnkControlGUI = new ControlGUI(name, this);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = lnkControlGUI.getSize();
        frameSize.height = ((frameSize.height > screenSize.height) ? screenSize.height : frameSize.height);
        frameSize.width = ((frameSize.width > screenSize.width) ? screenSize.width : frameSize.width);
        lnkControlGUI.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        lnkControlGUI.setVisible(true);
        addBehaviour(new ListRefreshBehaviour(this, 2000));
        addBehaviour(new ControlRequestBehaviour(this));
    }

    protected void onGuiEvent(GuiEvent e) {
        if (e.getType() == this.EXIT_EVENT) this.doDelete();
    }

    public void addPlaygroundData(PlaygroundData pd) {
        DataManager.getInstance().addPlaygroundData(pd);
    }

    public void takeDown() {
        System.out.println("Agent wird beendet");
        //hier alles eintragen, was vor dem Beenden getan werden mu.
    }

    class ListRefreshBehaviour extends WakerBehaviour {
        public ListRefreshBehaviour(Agent a, long timeout) {
            super(a, timeout);
        }

        protected void handleElapsedTimeout() {
            //frage nach allen Spielfeldern
            try {
                ServiceDescription sd = new ServiceDescription();
                sd.setType("Playground");
                DFAgentDescription agentDescription = new DFAgentDescription();
                agentDescription.addServices(sd);
                DFAgentDescription d[] = DFService.search(myAgent, agentDescription);
                DataManager.getInstance().checkExistance(d);
                //Frage bei allen Brettern nach Daten
                for (int i = 0; i < d.length; i++) {
                    DFAgentDescription ad = d[i];
                    //frage Playground nach Daten
                    ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
                    AID aid = new AID();
                    aid.setName(ad.getName().getName());
                    reply.setSender(myAgent.getAID());
                    reply.addReceiver(aid);
                    reply.setLanguage("getContent");
                    myAgent.send(reply);
                }
            }
            catch (FIPAException e) { e.printStackTrace(); }
            myAgent.addBehaviour(new ListRefreshBehaviour(myAgent, 2000));
        }
    }
}
