/* Generated by Together */

package pacman.control;

import javax.swing.JFrame;
import java.awt.event.WindowEvent;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import java.awt.BorderLayout;
import pacman.data.PlaygroundCollection;
import pacman.data.PlaygroundData;
import jade.gui.GuiEvent;
import jade.core.Agent;
import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;
import jade.wrapper.AgentController;
import jade.wrapper.StaleProxyException;
import jade.wrapper.ControllerException;
import java.awt.FlowLayout;

public class ControlGUI extends JFrame {
    //    private ControlAgent myAgent;
    private JTabbedPane myTabbedPane = new JTabbedPane();
    private JPanel playgroundTab = new JPanel();
    private JPanel characterTab = new JPanel();
    private JPanel aboutTab = new JPanel();
    private JTextArea aboutTextArea = new JTextArea();
    private PlaygroundTable lnkPlaygroundTable;
    private DetailTable lnkDetailTable;
    private VorschauPanel vorschau;
    private JPanel panel = new JPanel();
    private Agent myAgent;

    public ControlGUI(String name, Agent myAgent) {
        super(name);
        this.myAgent = myAgent;
        vorschau = new VorschauPanel();
        lnkPlaygroundTable = new PlaygroundTable(this, myAgent, vorschau);
        lnkDetailTable = new DetailTable(this, myAgent, vorschau);
        initGUI();
        pack();
    }

    /** This method is called from within the constructor to initialize the form. */
    private void initGUI() {
        addWindowListener(
            new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent evt) {
                    exitForm();
                }
            });
        setBounds(new java.awt.Rectangle(0, 0, 600, 571));
        getContentPane().add(myTabbedPane, java.awt.BorderLayout.CENTER);
        myTabbedPane.add(playgroundTab, "Playground");
        myTabbedPane.add(characterTab, "Character");
        myTabbedPane.add(aboutTab, "About");
        aboutTextArea.setText("ControlAgent programmed by Andreas Martmann");
        aboutTextArea.setEditable(false);
        aboutTab.setLayout(new java.awt.BorderLayout());
        aboutTab.add(aboutTextArea, java.awt.BorderLayout.CENTER);
        JButton newHeroButton = new JButton("new Hero");
        newHeroButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) { startNewHero(); }
            });
        JButton newMonsterButton = new JButton("new Monster");
        newMonsterButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) { startNewMonster(); }
            });
        characterTab.setLayout(new FlowLayout());
        characterTab.add(newMonsterButton);
        characterTab.add(newHeroButton);
        panel.setMinimumSize(new Dimension(130, 100));
        panel.setSize(new Dimension(130, 100));
        panel.setMaximumSize(new Dimension(130, 100));
        panel.add(vorschau);
        panel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153), 1),
            "Preview", javax.swing.border.TitledBorder.LEADING, javax.swing.border.TitledBorder.TOP, new java.awt.Font("SansSerif", 0, 11),
            new java.awt.Color(60, 60, 60)));
        playgroundTab.setLayout(new BorderLayout());
        playgroundTab.add(lnkPlaygroundTable, BorderLayout.NORTH);
        playgroundTab.add(lnkDetailTable, BorderLayout.CENTER);
        playgroundTab.add(panel, BorderLayout.EAST);
    }

    /** Exit the Application */
    private void exitForm() {
        this.dispose();
        ((ControlAgent)myAgent).postGuiEvent(new GuiEvent(this, ControlAgent.EXIT_EVENT));
    }

    public void setDetailTableData(String name) {
        lnkDetailTable.setDetailTableData(name);
    }

    public void startNewHero() {
        String name = JOptionPane.showInputDialog(this, "Enter Agent name", "Question", JOptionPane.QUESTION_MESSAGE);
		String playground = JOptionPane.showInputDialog(this,"Choose Playground","Question",JOptionPane.QUESTION_MESSAGE);
		if (playground ==null) return;
        Object args[] = new Object[1];
        args[0] = playground;
        try {
            AgentController agentController = myAgent.getContainerController().createNewAgent(name, "pacman.character.Hero", args);
            agentController.start();
        }
        catch (StaleProxyException e) {e.printStackTrace(); }
        catch (ControllerException e) {e.printStackTrace(); }
    }

    public void startNewMonster() {
        String name = JOptionPane.showInputDialog(this, "Enter Agent name", "Question", JOptionPane.QUESTION_MESSAGE);
        String playground = JOptionPane.showInputDialog(this,"Choose Playground","Question",JOptionPane.QUESTION_MESSAGE);
		if (playground ==null) return;
        Object args[] = new Object[1];
        args[0] = playground;
        try {
            AgentController agentController = myAgent.getContainerController().createNewAgent(name, "pacman.character.Monster", args);
            agentController.start();
        }
        catch (StaleProxyException e) {e.printStackTrace(); }
        catch (ControllerException e) {e.printStackTrace(); }
    }
}
