/* Generated by Together */

package pacman.control;

import javax.swing.JTable;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import javax.swing.table.AbstractTableModel;
import javax.swing.JButton;
import pacman.data.PlaygroundData;
import javax.swing.ListSelectionModel;
import pacman.data.ExitData;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import jade.core.Agent;
import pacman.data.Koordinate;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

public class DetailTable extends JPanel {
    private JTable table;
    private MyDetailTableModel myModel;
    private JPanel buttonPanel = new JPanel();
    private JButton changeButton = new JButton();
    private ControlGUI gui;
    private Agent agent;
    private VorschauPanel vorschau;

    public DetailTable(ControlGUI gui, Agent agent, VorschauPanel vorschau) {
        initGUI();
        this.gui = gui;
        this.agent = agent;
        this.vorschau = vorschau;
    }

    public void initGUI() {
        setLayout(new java.awt.BorderLayout());
        myModel = new MyDetailTableModel(this);
        table = new JTable(myModel);
        table.setPreferredScrollableViewportSize(new Dimension(500, 70));
        table.setRowSelectionAllowed(true);
        table.setColumnSelectionAllowed(false);
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        ListSelectionModel rowSM = table.getSelectionModel();
        rowSM.addListSelectionListener(
            new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {
                    //Ignore extra messages.
                    if (e.getValueIsAdjusting())
                        return;
                    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                    if (lsm.isSelectionEmpty()) {
                        //keine Zeilen selektiert -> Detailtabelle lschen
                        changeButton.setEnabled(false);
                        vorschau.setKoordinates(null);
                    }
                    else {
                        changeButton.setEnabled(true);
                        String name = myModel.getName();
                        int row = table.getSelectedRow();
                        if (row != -1) {
                            vorschau.setKoordinates(DataManager.getInstance().getPlaygroundCollection().getPlaygroundByName(
                                name).getExit(row).getKoordinate());
                        }
                        else
                            vorschau.setKoordinates(null);
                    }
                }
            });
        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);
        //Set up column sizes.
        table.getColumnModel().getColumn(0).setPreferredWidth(8);
        table.getColumnModel().getColumn(1).setPreferredWidth(8);
        table.getColumnModel().getColumn(2).setPreferredWidth(150);
        table.getColumnModel().getColumn(3).setPreferredWidth(8);
        table.getColumnModel().getColumn(4).setPreferredWidth(8);
        add(buttonPanel, java.awt.BorderLayout.EAST);
        add(scrollPane, BorderLayout.CENTER);
        changeButton.setLabel("Set Connection");
        changeButton.setEnabled(false);
        changeButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String name = myModel.getName();
                    int row = table.getSelectedRow();
                    if (row != -1) {
                        Koordinate tmpKoord = DataManager.getInstance().getPlaygroundCollection().getPlaygroundByName(name
                            ).getExit(row).getKoordinate();
                        ConnectDialog cd = new ConnectDialog(gui, true, name, tmpKoord, agent);
                        cd.setSize(320, 170);
                        cd.setLocation(260, 170);
                        cd.setVisible(true);
                    }
                }
            });
        buttonPanel.setLayout(new java.awt.FlowLayout());
        buttonPanel.add(changeButton);
    }

    public void setDetailTableData(String name) {
        myModel.setDetailTableData(name);
    }

    class MyDetailTableModel extends AbstractTableModel {
        private String[] columnNames = {"X","Y","Host","X","Y"};
        private DetailTable table;
        private String name = "";
        private final int X = 0;
        private final int Y = 1;
        private final int HOST = 2;
        private final int HX = 3;
        private final int HY = 4;

        public MyDetailTableModel(DetailTable table) {
            this.table = table;
        }

        public String getName() {
            return name;
        }

        public int getColumnCount() {
            return columnNames.length;
        }

        public int getRowCount() {
            if (name == null || name.equals(""))
                return 0;
            else
                return DataManager.getInstance().getPlaygroundCollection().getPlaygroundByName(name).getExitCount();
        }

        public String getColumnName(int col) {
            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
            ExitData ed = DataManager.getInstance().getPlaygroundCollection().getPlaygroundByName(name).getExit(row);
            switch (col) {
                case X:
                    return "" + ed.getKoordinate().getX();
                case Y:
                    return "" + ed.getKoordinate().getY();
                case HOST:
                    if (ed.isConnected())
                        return ed.getConnectedField();
                    else
                        return "not connected";
                case HX:
                    if (ed.isConnected())
                        return "" + ed.getConnectedKoord().getX();
                    else
                        return "n.c.";
                case HY:
                    if (ed.isConnected())
                        return "" + ed.getConnectedKoord().getY();
                    else
                        return "n.c.";
                default:
                    return null;
            }
        }

        public boolean isCellEditable(int row, int col) {
            return false;
        }

        public void setDetailTableData(String name) {
            this.name = name;
            this.fireTableDataChanged();
        }
    }
}
