/* Generated by Together */

package pacman.control;

import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import java.awt.BorderLayout;
import javax.swing.JComboBox;
import javax.swing.DefaultCellEditor;
import javax.swing.table.AbstractTableModel;
import pacman.data.ExitData;
import java.util.ArrayList;
import pacman.data.PlaygroundCollection;
import pacman.data.PlaygroundData;
import javax.swing.event.TableModelEvent;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import jade.lang.acl.ACLMessage;
import jade.core.AID;
import java.io.IOException;
import jade.core.Agent;
import jade.wrapper.AgentController;
import javax.swing.JOptionPane;
import javax.swing.JFileChooser;
import jade.wrapper.StaleProxyException;
import jade.wrapper.ControllerException;
import jade.core.Profile;
import jade.core.ProfileImpl;
import jade.wrapper.AgentContainer;

public class PlaygroundTable extends JPanel {
    private JTable table;
    private MyTableModel myModel;
    private ControlGUI gui;
    private Agent myAgent;
    private JButton deleteButton;
    private DeleteActionListener deleteListener;
    private VorschauPanel vorschau;

    public PlaygroundTable(ControlGUI gui, Agent agent, VorschauPanel vorschau) {
        this.gui = gui;
        this.myAgent = agent;
        this.vorschau = vorschau;
        deleteListener = new DeleteActionListener(vorschau);
        initGUI();
    }

    /** This method is called from within the constructor to initialize the form. */
    public void initGUI() {
        setLayout(new java.awt.BorderLayout());
        myModel = new MyTableModel(this);
        table = new JTable(myModel);
        table.setPreferredScrollableViewportSize(new Dimension(500, 70));
        table.setRowSelectionAllowed(true);
        table.setColumnSelectionAllowed(false);
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        ListSelectionModel rowSM = table.getSelectionModel();
        rowSM.addListSelectionListener(
            new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {
                    //Ignore extra messages.
                    if (e.getValueIsAdjusting())
                        return;
                    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                    if (lsm.isSelectionEmpty()) {
                        //keine Zeilen selektiert -> Detailtabelle lschen
                        gui.setDetailTableData(null);
                        deleteButton.setEnabled(false);
                        deleteListener.setSelected("");
                        vorschau.setName(null);
                    }
                    else {
                        int selectedRow = lsm.getMinSelectionIndex();
                        //selectedRow is selected
                        gui.setDetailTableData(myModel.getName(selectedRow));
                        deleteButton.setEnabled(true);
                        deleteListener.setSelected(myModel.getName(selectedRow));
                        vorschau.setName(myModel.getName(selectedRow));
                    }
                }
            });
        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);
        //Set up column sizes.
        table.getColumnModel().getColumn(0).setPreferredWidth(180);
        table.getColumnModel().getColumn(1).setPreferredWidth(10);
        table.getColumnModel().getColumn(2).setPreferredWidth(10);
        add(scrollPane, BorderLayout.CENTER);
        JPanel buttonPanel = new JPanel();
        JButton newButton = new JButton("New");
        newButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    String name = JOptionPane.showInputDialog(gui, "Enter Playground name", "Question",
                        JOptionPane.QUESTION_MESSAGE);
                    JFileChooser chooser = new JFileChooser();
                    int returnVal = chooser.showOpenDialog(gui);
                    if (returnVal == JFileChooser.APPROVE_OPTION) {
                        System.out.println("You chose to open this file: " + chooser.getSelectedFile().getPath());
                        Object args[] = new Object[1];
                        args[0] = chooser.getSelectedFile().getPath();
                        try {
                            AgentController agentController =
                                DataManager.getInstance().getNewContainer(gui).createNewAgent(name,
                                "pacman.playground.PlaygroundAgent", args);
                            agentController.start();
                        }
                        catch (StaleProxyException f) { f.printStackTrace(); }
                        catch (ControllerException g) { g.printStackTrace(); }
                    }
                }
            });
        deleteButton = new JButton("Delete");
        deleteButton.setEnabled(false);
        deleteButton.addActionListener(deleteListener);
        buttonPanel.add(newButton);
        buttonPanel.add(deleteButton);
        add(buttonPanel, BorderLayout.EAST);
    }

    class MyTableModel extends AbstractTableModel {
        private String[] columnNames = {"Name","Count","Free"};
        private PlaygroundTable table;

        public MyTableModel(PlaygroundTable table) {
            //registrieren bei dem DataManager
            DataManager.getInstance().registerTableModel(this);
            this.table = table;
        }

        public int getColumnCount() {
            return columnNames.length;
        }

        public int getRowCount() {
            return DataManager.getInstance().getPlaygroundCollection().getPlaygroundCount();
        }

        public String getColumnName(int col) {
            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
            PlaygroundData tmpPD = DataManager.getInstance().getPlaygroundCollection().getPlaygroundAt(row);
            String name = tmpPD.getName().getName();
            switch (col) {
                case 0:
                    return name;
                case 1:
                    return "" + tmpPD.getExitCount();
                case 2:
                    return "" + tmpPD.getFreeExitCount();
                default:
                    return null;
            }
        }

        public String getName(int row) {
            return DataManager.getInstance().getPlaygroundCollection().getPlaygroundAt(row).getName().getName();
        }

        public boolean isCellEditable(int row, int col) {
            return false;
        }
    }


    public class DeleteActionListener implements ActionListener {
        private VorschauPanel vorschau;

        public DeleteActionListener(VorschauPanel vorschau) {
            this.vorschau = vorschau;
        }

        String selected = "";

        public void setSelected(String name) {
            selected = name;
        }

        public void actionPerformed(ActionEvent e) {
            System.out.println("delete Knopf gedrckt");
            vorschau.setName(null);
            //schicke Nachricht an Playground
            ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
            AID aid = new AID();
            aid.setName(selected);
            reply.addReceiver(aid);
            reply.setLanguage("destroy");
            myAgent.send(reply);
        }
    }
}
