/* Generated by Together */

package pacman.control;

import javax.swing.JPanel;
import java.awt.Graphics;
import java.util.ArrayList;
import pacman.data.Koordinate;
import java.util.Iterator;
import java.awt.Color;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class VorschauPanel extends JPanel {
    private String name = null;
    private Koordinate koord = null;
    private boolean active = false;
    private Timer timer;

    /** Creates new form VorschauPanel */
    public VorschauPanel() {
        initGUI();
    }

    /** This method is called from within the constructor to initialize the form. */
    private void initGUI() {
        timer = new Timer(500, new TimerListener(this));
        setLayout(new java.awt.BorderLayout());
        setMinimumSize(new java.awt.Dimension(180, 150));
        setPreferredSize(new java.awt.Dimension(180, 120));
        setSize(new java.awt.Dimension(180, 120));
    }

    public void paint(Graphics g) {
        g.setColor(Color.lightGray);
        g.fillRect(0, 0, 200, 200);
        int height = (int)this.getSize().getHeight();
        int width = (int)this.getSize().getWidth();
        int br = 0;
        int h = 0;
        if (name != null) {
            ArrayList playground = DataManager.getInstance().getPlaygroundCollection().getPlaygroundByName(name
                ).getPlayground();
            Iterator a;
            br = ((ArrayList)playground.get(0)).size() * 3;
            h = playground.size() * 3;
            int x = (width - br) / 2;
            int y = (height - h) / 2;
            String feld;
            for (Iterator b = playground.iterator(); b.hasNext(); ) {
                a = ((ArrayList)b.next()).iterator();
                x = (width - br) / 2;
                while (a.hasNext()) {
                    feld = (String)a.next();
                    if (feld.equals("C"))
                        g.setColor(Color.gray);
                    else if (feld.equals("P"))
                        g.setColor(Color.lightGray);
                    else if (feld.equals("W"))
                        g.setColor(Color.blue);
                    else
                        g.setColor(Color.white);
                    g.fillRect(x, y, 3, 3);
                    x = x + 3;
                }
                y = y + 3;
            }
        }
        if (koord != null && active) {
            g.setColor(Color.red);
            g.fillRect((width - br) / 2 + koord.getX() * 3, (height - h) / 2 + koord.getY() * 3, 3, 3);
        }
    }

    public void setName(String name) {
        this.name = name;
        if (name != null)
            active = true;
        else
            active = false;
        repaint();
    }

    public void setKoordinates(Koordinate koord) {
        this.koord = koord;
        if (koord != null)
            timer.start();
        else
            timer.stop();
        repaint();
    }

    public class TimerListener implements ActionListener {
        private VorschauPanel vorschau;

        public TimerListener(VorschauPanel vorschau) {
            this.vorschau = vorschau;
        }

        public void actionPerformed(ActionEvent e) {
            active = !active;
            vorschau.repaint();
        }
    }
}
