package pacman.controller;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import jade.core.behaviours.OneShotBehaviour;

public class ControllerFrame extends JFrame {
   JPanel jPanel1 = new JPanel();
   JPanel jPanel2 = new JPanel();
   JButton jButton1 = new JButton();
   JButton jButton2 = new JButton();
   JButton jButton3 = new JButton();

   private ControllerAgent owner;
   FlowLayout flowLayout1 = new FlowLayout();
   JTextArea jTextArea1 = new JTextArea();
   JLabel jLabel1 = new JLabel();
   BorderLayout borderLayout1 = new BorderLayout();

   public ControllerFrame(ControllerAgent owner) {

      this.owner = owner;

      try {
         jbInit();
      }
      catch(Exception e) {
         e.printStackTrace();
      }
   }


   private void jbInit() throws Exception {
      this.getContentPane().setLayout(borderLayout1);
      this.getContentPane().setBackground(Color.white);
      this.setSize(300,270);
      this.setResizable(false);
      this.setTitle("PacMan-Controller");

      //Auf Tastendr?cke reagieren

      KeyListener myListener = new KeyListener()
      {
         public void keyTyped(KeyEvent e){}

         public void keyPressed(KeyEvent e)
         {
            char temp;
            final int ccode = e.getKeyCode();
            if (ccode==KeyEvent.VK_UP) {temp = 'n';}
            else if (ccode==KeyEvent.VK_DOWN) {temp = 's';}
            else if (ccode==KeyEvent.VK_LEFT) {temp = 'w';}
            else if (ccode==KeyEvent.VK_RIGHT) {temp = 'e';}
            else temp = e.getKeyChar();
            final char c = temp;

            System.out.print("KeyCode: ");
            System.out.println(ccode);
            System.out.print("KeyTyped: ");
            System.out.println(c);
            System.out.print("NumericValue of Char: ");
            System.out.println(Character.getNumericValue(c));

            if (c=='n'||c=='s'||c=='e'||c=='w')
            {
               System.out.print("Richtungswechselanforderung nach ");
               System.out.print(c);
               System.out.println(" erhalten");
               owner.addBehaviour
                  ( new OneShotBehaviour()
                   {
                     public void action() {((ControllerAgent) myAgent).changeDirectionTo(c);}
                  }
               );
            }
            else if (c == 's')
            {
               System.out.println("South");
            }
            else if (c == 'w')
            {
               System.out.println("West");
            }
            else if (c == 'e')
            {
               System.out.println("East");
            }
            else {System.out.println("Unbekannte Taste");}


            /*char c = e.getKeyChar();
            if (c == 'C')
              {
                System.out.println("habe C empfangen");
                 jLabel2.setText("Center");
              }
              else {
              jLabel2.setText("andereTaste");
              System.out.println("KeyPressed ");
              };*/
         }

         public void keyReleased(KeyEvent e){}
      };

      jPanel1.addKeyListener(myListener);
      jPanel2.addKeyListener(myListener);
      jButton1.addKeyListener(myListener);
      jButton2.addKeyListener(myListener);
      jButton3.addKeyListener(myListener);
      jTextArea1.addKeyListener(myListener);
      jLabel1.addKeyListener(myListener);
      this.addKeyListener(myListener);

      jButton1.setText("Connect");
      jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
               jButton1_actionPerformed(e);
            }
         });
      jButton2.setText("Disconnect");
      jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
               jButton2_actionPerformed(e);
            }
         });
      jButton3.setText("Exit");
      jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
               jButton3_actionPerformed(e);
            }
         });
      jPanel2.setBackground(Color.black);
      jPanel2.setMaximumSize(new Dimension(300, 255));
      jPanel2.setMinimumSize(new Dimension(300, 40));
      jPanel2.setPreferredSize(new Dimension(300, 40));
      jPanel1.setLayout(flowLayout1);
      jPanel1.setBackground(Color.black);
      jPanel1.setMaximumSize(new Dimension(300, 255));
      jPanel1.setMinimumSize(new Dimension(300, 215));
      jPanel1.setPreferredSize(new Dimension(300, 215));
      jTextArea1.setBackground(Color.lightGray);
      jTextArea1.setForeground(Color.blue);
      jTextArea1.setBorder(BorderFactory.createLoweredBevelBorder());
      jTextArea1.setPreferredSize(new Dimension(255, 155));
      jTextArea1.setEditable(false);
      jTextArea1.setMargin(new Insets(5, 5, 5, 5));
      jTextArea1.setText("\"Connect\" drcken, um einen Helden oder ein Monster zu Steuerung " +
                         "auszuwhlen, \"Disconnect\" um die Steuerung wieder an den Character " +
                         "zurckzugeben und \"Exit\", um den Controller zu beenden. Erlaubte " +
                         "Tasten sind die Cursortasten oder n,s,o,w fr Nord, Sd, Ost, West. " +
                         "Viel Spa ;-)");
      jTextArea1.setLineWrap(true);
      jTextArea1.setRows(1);
      jTextArea1.setWrapStyleWord(true);
      jLabel1.setFont(new java.awt.Font("Dialog", 1, 24));
      jLabel1.setForeground(Color.orange);
      jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
      jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
      jLabel1.setText("PacMan-Controller");
      jPanel2.add(jButton1, null);
      jPanel2.add(jButton2, null);
      jPanel2.add(jButton3, null);
      this.getContentPane().add(jPanel1, BorderLayout.CENTER);
      jPanel1.add(jLabel1, null);
      jPanel1.add(jTextArea1, null);
      this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
   }

   void jButton3_actionPerformed(ActionEvent e) {
      owner.doDelete();
   }

   void jButton1_actionPerformed(ActionEvent e) {
      owner.addBehaviour( new OneShotBehaviour() {
            public void action() {
               ((ControllerAgent) myAgent).connectToCharacter();
            }
         } );
   }

   void jButton2_actionPerformed(ActionEvent e) {
      owner.addBehaviour( new OneShotBehaviour() {
            public void action() {
               ((ControllerAgent) myAgent).disconnectFromCharacter();
            }} );
   }}
