/*
 * GUIAgent.java
 *
 * Created on 14. Juni 2002, 11:39
 */

package pacman.gui;

// Imports
///////////////
import pacman.data.*;

import jade.core.AID;
import jade.core.Agent;
import jade.core.ProfileImpl;
import jade.core.Profile;

import jade.wrapper.AgentContainer;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;

import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;

import javax.swing.*;
import java.util.*;
import java.text.NumberFormat;


/**
 *
 * @author  irek
 * @version
 */
public class GUIAgent extends Agent {
    
    // Instance variables
    //////////////////////////////////
    protected GUIAgentFrame myFrame = null;
    
    protected String GUIRegisteredToPlayground = "";
    
    // Jeweils 40 Heros und Monster sollte vorerst reichen
    protected String[][] herodata = new String[40][3];      // hier sind einfach die Namen der heros eingetragen.
    protected String[] monsterdata = new String[40];        // anhand der Position weden dann die Farben gewhlt
    
    // - herodata[0] enthlt den Namen des Charakters
    // - herodata[1] enthlt die Punkte der heros, die in der Titelleiste angezeigt werden.
    // - herodata[2] enthlt die Anzahl der Leben...
    
    protected ArrayList playground;
    protected ArrayList monsters;
    protected ArrayList heros;
    
    
    /** Creates new GUIAgent */
    public GUIAgent() {
    }
    
    /**
     * Setup the agent.  Registers with the DF, and adds a behaviour to
     * process incoming messages.
     */
    protected void setup() {
        try {
            System.out.println( "GUIAgent: " + getLocalName() + " setting up.");
            
            // create the agent descrption of itself
            // DFAgentDescription dfd = new DFAgentDescription();
            // dfd.setName( getAID() );
            // DFService.register( this, dfd );
            
            
            // add the GUI
            System.out.println( "setting up Frame...");
            setupUI();
            
            
            addBehaviour(new GUIRequestBehaviour(this));
            
            
        }
        catch (Exception e) {
            System.out.println( "Saw exception in HostAgent: " + e );
            e.printStackTrace();
        }
        
    }
    
    // Internal implementation methods
    //////////////////////////////////
    
    
    /**
     * Setup the UI, which means creating and showing the main frame.
     */
    private void setupUI() {
        myFrame = new GUIAgentFrame( this );
        myFrame.setVisible( true );
        myFrame.setButtonStatus();
    }
    
    
    
    /**
     * Shut down the host agent, including removing the UI and deregistering
     * from the DF.
     */
    protected void terminateHost() {
        try {
            // DFService.deregister( this );
            doDelete();
        }
        catch (Exception e) {
            System.err.println( "Saw FIPAException while terminating: " + e );
            e.printStackTrace();
        }
    }
    
    
    public void setPlaygroundContent(PlaygroundData playgroundData) {
        
        
        playground = playgroundData.getPlayground();
        monsters = playgroundData.getMonster();
        heros = playgroundData.getHeros();
        
        // Falls von mir keine GUI registriert wurde, wird auch kein Feld angezeigt!!!
        // => muss aufgrund der langen laufzeiten geschehen, da auch noch nach dem
        //    abmelden noch ein/zwei weitere Felder kommen knnen
        if (GUIRegisteredToPlayground.equals("")) {
            myFrame.setTitle("GUIAgent");
            return;
        }
        else
            myFrame.setTitle("GUIAgent - " + GUIRegisteredToPlayground);
        
        
        
        int feldy = playground.size();
        int feldx = ((ArrayList) playground.get(0)).size();
        
        
        
        ////////////////////////////////////////////////////////////////
        // muss ein neues Spielfeld angelegt werden ???
        if ( myFrame.feldSizeX != feldx || myFrame.feldSizeY != feldy ) {
            myFrame.feld = new GUISpielfeldElement[feldy][feldx];
            myFrame.feldSizeX = feldx;
            myFrame.feldSizeY = feldy;
            myFrame.setPanelSize(feldx, feldy);
            for ( int i = 0; i < feldy; i++ )
                for ( int j = 0; j < feldx; j++ )
                    myFrame.feld[i][j] = new GUISpielfeldElement();
        }
        // so, hier existiert auf jeden Fall ein Feld mit den richtigen Dimensionen
        
        
        ////////////////////////////////////////////////////////////////
        //kopiere Spielfeld
        // => hier noch das reine Feld
        Iterator a = playground.iterator();
        Iterator b;
        int i = 0, j = 0;
        String s;
        while (a.hasNext()) {
            b = ((ArrayList)a.next()).iterator();
            while (b.hasNext()) {
                s = (String)b.next();
                
                if (s.equals("W"))
                    myFrame.feld[i][j].typ = 3;
                else if (s.equals("P"))
                    if ( i == 0 || j == 0 || i == feldy-1 || j == feldx-1 )
                        myFrame.feld[i][j].typ = 5;
                    else
                        myFrame.feld[i][j].typ = 4;
                else if (s.equals("C"))
                    myFrame.feld[i][j].typ = 0;
                else if (s.equals("S"))
                    myFrame.feld[i][j].typ = 1;
                else if (s.equals("M"))
                    myFrame.feld[i][j].typ = 2;
                else {
                    System.out.println("GUIAgent: Habe mir unbekanntes Zeichen gelesen: " + s);
                }
                j++;
            }
            i++;
            j = 0;
        }
        
        
        
        ////////////////////////////////////////////////////////////////
        //fge Helden zum Spielfeld hinzu
        Iterator hi = heros.iterator();
        HeroData h;
        int farbe;
        
        while (hi.hasNext()) {
            h = (HeroData)hi.next();
            if (h == null)
                System.out.println("h ist null");
            
            // Ist der Hero schon bei mir eingetragen ???
            int k = -1;
            boolean found = false;
            while (k < 39 && !found) {
                k++;
                if (herodata[k][0] != null && herodata[k][0].equals(h.getName()))
                    found = true;
            }
            
            // Der hero ist neu!!!
            if (!found) {
                k = -1;
                while (k < 39 && !found) {
                    k++;
                    if (herodata[k][0] == null) {
                        found = true;
                        herodata[k][0] = h.getName();
                        herodata[k][1] = "???";
                        herodata[k][2] = "???";
                    }
                }
                // und noch bei diesem Character eintragen
                registerGUIToCharacter(h.getName());
            }
            
            // noch in Farben umrechnen
            farbe = k % 7;
            
            myFrame.feld[h.getY()][h.getX()].typ = 10;
            myFrame.feld[h.getY()][h.getX()].farbe = farbe;
            if (h.getDirection().equals("E"))
                myFrame.feld[h.getY()][h.getX()].richtung = 0;
            else if (h.getDirection().equals("S"))
                myFrame.feld[h.getY()][h.getX()].richtung = 1;
            else if (h.getDirection().equals("W"))
                myFrame.feld[h.getY()][h.getX()].richtung = 2;
            else if (h.getDirection().equals("N"))
                myFrame.feld[h.getY()][h.getX()].richtung = 3;
        }
        
        
        
        ////////////////////////////////////////////////////////////////
        //fge Monster zum Spielfeld hinzu
        Iterator mo = monsters.iterator();
        MonsterData m;
        
        while (mo.hasNext()) {
            m = (MonsterData)mo.next();
            if (m == null)
                System.out.println("m ist null");
            
            // Ist der Hero schon bei mir eingetragen ???
            int k = -1;
            boolean found = false;
            while (k < 39 && !found) {
                k++;
                if (monsterdata[k] != null && monsterdata[k].equals(m.getName()))
                    found = true;
            }
            
            // das Monster ist neu!!!
            if (!found) {
                k = -1;
                while (k < 39 && !found) {
                    k++;
                    if (monsterdata[k] == null) {
                        found = true;
                        monsterdata[k] = m.getName();
                    }
                }
                // und noch bei diesem Character eintragen
                registerGUIToCharacter(m.getName());
                
            }
            
            // noch in Farben umrechnen
            farbe = k % 6;
            
            myFrame.feld[m.getY()][m.getX()].typ = 11;
            myFrame.feld[m.getY()][m.getX()].farbe = farbe;
            if (m.getDirection().equals("E"))
                myFrame.feld[m.getY()][m.getX()].richtung = 0;
            else if (m.getDirection().equals("S"))
                myFrame.feld[m.getY()][m.getX()].richtung = 1;
            else if (m.getDirection().equals("W"))
                myFrame.feld[m.getY()][m.getX()].richtung = 2;
            else if (m.getDirection().equals("N"))
                myFrame.feld[m.getY()][m.getX()].richtung = 3;
        }
        
        
        
        
        // und nochmal neuzeichnen !!!
        myFrame.listModel.fireContentsChanged();
        myFrame.refreshTopView();
        myFrame.repaint();
    }
    
    
    
    
    
    public void registerGUIToPlayground() {
        
        String s = null;
        
        try {
            
            ServiceDescription sd = new ServiceDescription();
            sd.setType( "Playground" );
            DFAgentDescription agentDescription = new DFAgentDescription();
            agentDescription.addServices( sd );
            DFAgentDescription d[] = DFService.search( this, agentDescription );
            
            if ( d.length == 0 ) {
                JOptionPane.showMessageDialog(null, "Kein Spielfeld gefunden.   :-(");
                return;
            }
            
            Object[] possibleValues = new Object[d.length];
            
            for ( int i = 0; i < d.length; i++ ) {
                DFAgentDescription ad = d[i];
                possibleValues[i] =  ad.getName().getName();
            }
            
            s = (String) JOptionPane.showInputDialog(null, "Welches Spielfeld soll angezeigt werden:", "Auswahl Spielfeld", JOptionPane.INFORMATION_MESSAGE, null, possibleValues, possibleValues[0]);
            
            // Es wurde kein Spielfeld gefunden
            if ( s == null )
                return;
            
            
        }
        catch ( FIPAException e ) { e.printStackTrace(); }
        
        
        
        System.out.println( "Registering at playground...");
        ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
        AID r = new AID();
        r.setName(s);
        msg.addReceiver(r);
        msg.setLanguage("registerGUIToPlayground");
        send(msg);
        
        GUIRegisteredToPlayground = s;
        myFrame.setButtonStatus();
    }
    
    
    public void deregisterGUIFromPlayground() {
        if (!GUIRegisteredToPlayground.equals("")) {
            System.out.println( "Deregistering from playground " + GUIRegisteredToPlayground);
            ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
            AID r = new AID();
            r.setName(GUIRegisteredToPlayground);
            msg.addReceiver(r);
            msg.setLanguage("deregisterGUIFromPlayground");
            send(msg);
            
            GUIRegisteredToPlayground = "";
            myFrame.setButtonStatus();
        }
        else  System.out.println( "No playground registered!!!");
        
    }
    
    
    public void registerGUIToCharacter(String name) {
        System.out.println( "Registering to character " + name);
        ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
        AID r = new AID();
        r.setName(name);
        msg.addReceiver(r);
        msg.setLanguage("registerGUIToCharacter");
        send(msg);
    }
    
    
    
    public void deregisterGUIFromAllCharacters() {
        for (int i = 0; i < 40; i++) {
            if (herodata[i][1] != null)
                if (!herodata[i][1].equals("")){
                    System.out.println( "Deregistering from character " + herodata[i][1]);
                    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
                    AID r = new AID();
                    r.setName(herodata[i][1]);
                    msg.addReceiver(r);
                    msg.setLanguage("deregisterGUIFromCharacter");
                    send(msg);
                }
            if (monsterdata[i] != null)
                if (!monsterdata[i].equals("")) {
                    System.out.println( "Deregistering from character " + monsterdata[i]);
                    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
                    AID r = new AID();
                    r.setName(monsterdata[i]);
                    msg.addReceiver(r);
                    msg.setLanguage("deregisterGUIFromCharacter");
                    send(msg);
                }
        }
    }
    
    
    
    public void doDelete() {
        System.out.println("Melde mich ab...");
        deregisterGUIFromPlayground();
        deregisterGUIFromAllCharacters();
        System.out.println("Beende GUIAgent");
        myFrame.dispose();
        //rufe Supermethode auf
        super.doDelete();
    }
    
    
}
