/*
 * GUIAgentFrame.java
 *
 * Created on 14. Juni 2002, 11:49
 */

package pacman.gui;

import jade.core.behaviours.OneShotBehaviour;
import java.awt.image.*;
import java.awt.*;
import javax.swing.JOptionPane;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.lang.acl.ACLMessage;
import jade.core.AID;


/**
 *
 * @author  irek
 */
public class GUIAgentFrame extends javax.swing.JFrame {
    
    protected GUIAgent owner;
    private String[] s = { "Punkt.gif", "Startfeld.gif", "StartfeldB.gif", "Wand.gif", "Weg.gif", "Ausgang.gif", "GameOver.gif" };
    protected Image[] bilder = new Image[7];
    protected Image[][] heros = new Image[7][4];
    protected Image[][] monster = new Image[6][4];
    protected Image[] heroImage = new Image[7];
    protected Image[] monsterImage = new Image[6];
    protected GUISpielfeldElement[][] feld;
    protected int feldSizeX = 1;
    protected int feldSizeY = 1;
    
    protected String lezterverfolgterCharacter = "";
    protected boolean leztercharacteristtot = false;
    
    protected MyAbstractListModel listModel;
    
    
    /** Creates new form GUIAgentFrame */
    public GUIAgentFrame(GUIAgent owner) {
        this.owner = owner;
        
        // Bilder laden
        for ( int i = 0; i < bilder.length; i++ )
            bilder[i] = getToolkit().createImage(getClass().getResource("/pacman/bitmaps/"+s[i]));
        for ( int i = 1; i <= 7; i++ ) {
            for (int j = 1; j <= 4; j++ )
                heros[i-1][j-1] = getToolkit().createImage(getClass().getResource("/pacman/bitmaps/P"+i+"-"+j+".gif"));
            heroImage[i-1] = getToolkit().createImage(getClass().getResource("/pacman/bitmaps/Pacman"+i+".gif"));
        }
        for ( int i = 1; i <= 6; i++ ) {
            for (int j = 1; j <= 4; j++ )
                monster[i-1][j-1] = getToolkit().createImage(getClass().getResource("/pacman/bitmaps/M"+i+"-"+j+".gif"));
            monsterImage[i-1] = getToolkit().createImage(getClass().getResource("/pacman/bitmaps/Monster"+i+".gif"));
        }
        
        
        
        // Feld initialisieren
        feld = new GUISpielfeldElement[1][1];
        feld[0][0] = new GUISpielfeldElement();
        
        // Fensterelemente anzeigen
        initComponents();
        
        // Panel einfgen
        panel = new GUIAgentPanel(this);
        panel.setPreferredSize(new java.awt.Dimension(1000, 1000));
        jScrollPane1.setViewportView(panel);
        
        // Anzeige der JList setzen
        listModel = new MyAbstractListModel(this);
        jList5.setModel(listModel);
        jList5.setCellRenderer(new MyCellRenderer(this));
        
        pack();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel4 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jButton4 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList5 = new javax.swing.JList();
        
        setTitle("GUIAgent");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        
        jButton2.setText("RegisterGUIAgent");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        
        jPanel4.add(jButton2);
        
        jButton3.setText("DeregisterGUIAgent");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        
        jPanel4.add(jButton3);
        
        jButton1.setText("Close GUIAgent");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        
        jPanel4.add(jButton1);
        
        getContentPane().add(jPanel4, java.awt.BorderLayout.SOUTH);
        
        jScrollPane1.setPreferredSize(new java.awt.Dimension(420, 420));
        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);
        
        jPanel3.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jPanel3.setMinimumSize(new java.awt.Dimension(70, 70));
        jPanel3.setPreferredSize(new java.awt.Dimension(1, 40));
        jLabel1.setAlignmentX(1.0F);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.gridheight = 2;
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 10, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 5.0;
        jPanel3.add(jLabel1, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 10, 10);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 5.0;
        jPanel3.add(jLabel2, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 10, 10);
        gridBagConstraints1.weightx = 5.0;
        jPanel3.add(jLabel4, gridBagConstraints1);
        
        jButton4.setText("disconnect");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel3.add(jButton4, gridBagConstraints1);
        
        getContentPane().add(jPanel3, java.awt.BorderLayout.NORTH);
        
        jScrollPane2.setPreferredSize(new java.awt.Dimension(150, 420));
        jList5.setModel(new javax.swing.AbstractListModel() {
            String[] strings = {  };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jList5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList5MouseClicked(evt);
            }
        });
        
        jScrollPane2.setViewportView(jList5);
        
        getContentPane().add(jScrollPane2, java.awt.BorderLayout.EAST);
        
        pack();
    }//GEN-END:initComponents
    
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        jList5.clearSelection();
        lezterverfolgterCharacter = "";
        leztercharacteristtot = false;
        refreshTopView();
    }//GEN-LAST:event_jButton4ActionPerformed
    
    private void jList5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList5MouseClicked
        leztercharacteristtot = false;
        refreshTopView();
    }//GEN-LAST:event_jList5MouseClicked
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        
        owner.addBehaviour( new OneShotBehaviour() {
            public void action() {
                ((GUIAgent) myAgent).registerGUIToPlayground();
            }
        } );
    }//GEN-LAST:event_jButton2ActionPerformed
    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        
        owner.addBehaviour( new OneShotBehaviour() {
            public void action() {
                ((GUIAgent) myAgent).deregisterGUIFromPlayground();
            }
        } );
        
        feld = new GUISpielfeldElement[1][1];
        feld[0][0] = new GUISpielfeldElement();
        feldSizeX = 1;
        feldSizeY = 1;
        setPanelSize(jScrollPane1.getSize().height, jScrollPane1.getSize().width);
        jLabel1.setText("");
        jLabel1.setIcon(null);
        jLabel2.setText("");
        
        this.repaint();
    }//GEN-LAST:event_jButton3ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        owner.addBehaviour( new OneShotBehaviour() {
            public void action() {
                ((GUIAgent) myAgent).terminateHost();
            }
        } );
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        owner.addBehaviour( new OneShotBehaviour() {
            public void action() {
                ((GUIAgent) myAgent).terminateHost();
            }
        } );
    }//GEN-LAST:event_exitForm
    
    
    
    public void setPanelSize(int x, int y) {
        panel.setPreferredSize(new Dimension(x*21, y*21));
        panel.setSize(x*21, y*21);
    }
    
    
    
    public void setButtonStatus() {
        if ( owner.GUIRegisteredToPlayground.equals("") ) {
            jButton3.setEnabled(false);
            jButton2.setEnabled(true);
        } else {
            jButton2.setEnabled(false);
            jButton3.setEnabled(true);
        }
    }
    
    
    public void refreshTopView() {
        int index = jList5.getSelectedIndex();
        
        // falls keine monster ausgewhlt einfach alles lschen
        if (index < 0) {
            jLabel1.setText("");
            jLabel1.setIcon(null);
            jLabel2.setText("");
            jLabel4.setText("");
            return;
        }
        
        pacman.data.CharacterData s;
        if (index < owner.heros.size()) {
            s = (pacman.data.CharacterData) owner.heros.get(index);
        } else {
            index -= owner.heros.size();
            s = (pacman.data.CharacterData) owner.monsters.get(index);
        }
        
        jLabel1.setText(s.getName());
        lezterverfolgterCharacter = s.getName();
        
        java.awt.Image image = null;
        
        if ( s instanceof pacman.data.HeroData ) {
            
            // welche Nummer hat er denn???
            int k = -1;
            boolean found = false;
            while (k < 39 && !found) {
                k++;
                if (owner.herodata[k][0] != null && owner.herodata[k][0].equals(s.getName()))
                    found = true;
            }
            
            image = heroImage[k % 7];
            
            jLabel2.setText("Punkte: " + owner.herodata[k][1]);
            jLabel4.setText("Leben: " + owner.herodata[k][2]);
            
        }
        else if ( s instanceof pacman.data.MonsterData ) {
            
            // welche Nummer hat er denn???
            int k = -1;
            boolean found = false;
            while (k < 39 && !found) {
                k++;
                if (owner.monsterdata[k] != null && owner.monsterdata[k].equals(s.getName()))
                    found = true;
            }
            
            image = monsterImage[k % 6];
            
            jLabel2.setText("Punkte: 3 auf der Stirn!!!");
            jLabel4.setText("Leben: genug");
            
        } else
            System.out.println("GUIAgentFrame.refreshTopView - unbekannte Klasse gefunden");
        
        jLabel1.setIcon( new javax.swing.ImageIcon(image) );
        
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel4;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JButton jButton4;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList jList5;
    // End of variables declaration//GEN-END:variables
    private GUIAgentPanel panel;
    
}


