package pacman.gui;

import pacman.data.PlaygroundData;
import jade.core.behaviours.*;
import jade.core.*;
import jade.lang.acl.*;

public class GUIRequestBehaviour extends SimpleBehaviour {
    
    private GUIAgent myParent;
    
    public GUIRequestBehaviour(Agent parent) {
        super(parent);
        myParent = (GUIAgent) parent;
    }
    
    public void action() {
        ACLMessage msg;
        // receive a new message
        msg = myAgent.receive();
        if (msg == null) {
            block();
            return;
        }
        else if (msg.getLanguage().equals("PlaygroundContent")) {
            try{
                ((GUIAgent)myAgent).setPlaygroundContent((PlaygroundData)(msg.getContentObject()));
            }catch(Exception e){
                e.printStackTrace();
            }
        }
        else if (msg.getLanguage().equals("deregisterCharacterFromGUI")) {
            System.out.println("habe deregisterCharacterFromGUI erhalten von "+ msg.getSender().getName());
        }
        
        
        else if (msg.getLanguage().equals("giveLifes")) {
            System.out.println("habe giveLifes erhalten von " + msg.getSender().getName());
            
            // Zuerst muss ich mir meinen Helden suchen
            int i = 0;
            boolean found = false;
            while (i < 40 && !found) {
                if (myParent.herodata[i][1] != null) {
                    if (!myParent.herodata[i][1].equals(msg.getSender())){
                        found = true;
                        myParent.herodata[i][2] = msg.getContent();
                    }
                }
                else if (myParent.monsterdata[i] != null)
                    if (!myParent.monsterdata[i].equals(msg.getSender())) {
                        found = true;
                        System.out.println("Monster " + msg.getSender().getName() + " hat " + msg.getContent() + " Leben ????");
                    }
                i++;
            }
            
        }
        else if (msg.getLanguage().equals("givePoints")) {
            System.out.println("habe givePoints erhalten von " + msg.getSender().getName());
            
            // Zuerst muss ich mir meinen Helden suchen
            int i = 0;
            boolean found = false;
            while (i < 40 && !found) {
                if (myParent.herodata[i][1] != null) {
                    if (!myParent.herodata[i][1].equals(msg.getSender())){
                        found = true;
                        myParent.herodata[i][1] = msg.getContent();
                    }
                }
                else if (myParent.monsterdata[i] != null)
                    if (!myParent.monsterdata[i].equals(msg.getSender())) {
                        found = true;
                        System.out.println("Monster " + msg.getSender().getName() + " hat " + msg.getContent() + " Punkte ????");
                    }
                i++;
            }
            
            
        }
        else if (msg.getLanguage().equals("notifyGUIOfDeath")) {
            System.out.println("habe notifyGUIOfDeath erhalten von " + msg.getSender().getName());
            if ( myParent.myFrame.lezterverfolgterCharacter.equals(msg.getSender().getName()) )
                myParent.myFrame.leztercharacteristtot = true;
        }
        else if (msg.getLanguage().equals("notifyGUIOfChangedField")) {
            System.out.println("habe notifyGUIOfChangedField erhalten von " + msg.getSender().getName());
        }
        else
            System.out.println("habe unbekannte Nachricht erhalten: " + msg.getLanguage()+ " von " + msg.getSender().getName());
        
        
    }
    
    public boolean done() {
        return false;
    }
}


