package pacman.gui;


import java.awt.*;




// Display an icon and a string for each object in the list.

class MyCellRenderer extends javax.swing.JLabel implements javax.swing.ListCellRenderer {
    
    GUIAgentFrame myFrame;
    
    // This is the only method defined by ListCellRenderer.
    // We just reconfigure the JLabel each time we're called.
    
    public MyCellRenderer(GUIAgentFrame frame) {
        super();
        this.myFrame = frame;
    }
    
    
    public Component getListCellRendererComponent(
    javax.swing.JList list,
    Object value,            // value to display
    int index,               // cell index
    boolean isSelected,      // is the cell selected
    boolean cellHasFocus)    // the list and the cell have the focus
    {
        pacman.data.CharacterData s = (pacman.data.CharacterData) value;
        setText(s.getName());
        
        java.awt.Image image= null;
        
        if ( s instanceof pacman.data.HeroData ) {
            
            // welche Nummer hat er denn???
            int k = -1;
            boolean found = false;
            while (k < 39 && !found) {
                k++;
                if (myFrame.owner.herodata[k][0] != null && myFrame.owner.herodata[k][0].equals(s.getName()))
                    found = true;
            }
            
            image = myFrame.heroImage[k % 7];
            
        }
        
        if ( s instanceof pacman.data.MonsterData ) {
            
            // welche Nummer hat er denn???
            int k = -1;
            boolean found = false;
            while (k < 39 && !found) {
                k++;
                if (myFrame.owner.monsterdata[k] != null && myFrame.owner.monsterdata[k].equals(s.getName()))
                    found = true;
            }
            
            image = myFrame.monsterImage[k % 6];
            
        }
        
        
        setIcon( new javax.swing.ImageIcon(image) );
        
        
        if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        }
        else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }
        setEnabled(list.isEnabled());
        setFont(list.getFont());
        setOpaque(true);
        return this;
    }
}
