package pacman.playground;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import jade.core.Agent;
import pacman.data.HeroData;
import pacman.data.MonsterData;
import pacman.data.ExitData;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;
import pacman.data.Koordinate;
import pacman.data.ConnectExit;
import jade.lang.acl.ACLMessage;
import jade.core.AID;

/**
 * <p>berschrift: </p> <p>Beschreibung: </p> <p>Copyright: Copyright (c) 2002</p> <p>Organisation: </p>
 * @author unbekannt
 * @version 1.0
 */
public class PlaygroundAgent extends Agent {
    /** @associates Monster */
    private ArrayList monsters = new ArrayList();

    /** @associates Hero */
    private ArrayList heros = new ArrayList();

    /** @associates ArrayList */
    private ArrayList playground = new ArrayList();

    /** @associates Exit */
    private ArrayList exits = new ArrayList();

    /** @associates String */
    private ArrayList registeredGUIs = new ArrayList();
    private int startX;
    private int startY;
    private int monsterStartX;
    private int monsterStartY;

    public PlaygroundAgent() { }

    public void setup() {
        // create the agent descrption of itself
        try {
            ServiceDescription sd = new ServiceDescription();
            sd.setType("Playground");
            sd.setName("Playground");
            DFAgentDescription dfd = new DFAgentDescription();
            dfd.setName(getAID());
            dfd.addServices(sd);
            // register the description with the DF
            DFService.register(this, dfd);
        }
        catch (FIPAException e) { e.printStackTrace(); }
        // add the RefreshBehaviour
        addBehaviour(new RefreshBehaviour(this, 1000));
        addBehaviour(new PlaygroundRequestBehaviour(this));
        initPlayground();
    }

    private void initPlayground() {
        Object[] obj = this.getArguments();
        String filename = "";
        if (obj.length > 0)
            filename = (String)obj[0];
        else
            doDelete();
        System.out.println(filename);
        String line;
        try {
            BufferedReader input = new BufferedReader(new FileReader(filename));
            System.out.println("Loading Playground...");
            while ((line = input.readLine()) != null) {
                System.out.println(line);
                addNewLine(line);
            }
            input.close();
        }
        catch (IOException e) { System.out.println("IO Error"); }
        searchSpecialFields();
    }

    private void addNewLine(String l) {
        String c;
        ArrayList newLine = new ArrayList();
        int length = l.length();
        for (int i = 0; i < length; i++) {
            c = l.substring(i, i + 1);
            newLine.add(c);
        }
        playground.add(newLine);
    }

    public void takeDown() {
        System.out.println("Beende Spielfeld (Exit) (takeDown)");
        //informiere alle Agenten
        //guis abkoppeln
        //Exits abkoppeln
        Iterator i = exits.iterator();
        while (i.hasNext()) {
            ExitData e = (ExitData)i.next();
            if (e.isConnected()) {
                this.closeOldConnection(e);
            }
        }
        //Monster und Helden abkoppeln
        //DF informieren, dass Spielfeld verschwindet
        try {
            DFService.deregister(this);
        }
        catch (FIPAException e) {
            e.printStackTrace();
        }
    }

    private void searchSpecialFields() {
        ArrayList line;
        String content;
        int size1 = playground.size();
        int size2;
        for (int i = 0; i < size1; i++) {
            line = (ArrayList)playground.get(i);
            size2 = line.size();
            for (int j = 0; j < size2; j++) {
                content = (String)line.get(j);
                //oberer Rand (P)
                if ((content.equals("P") || content.equals("C")) && (i == 0 || i == (playground.size() - 1))) {
                    exits.add(new ExitData(new Koordinate(j, i), content));
                    line.set(j, "W");
                }
                else if ((content.equals("P") || content.equals("C")) && (j == 0 || j == (line.size() - 1))) {
                    exits.add(new ExitData(new Koordinate(j, i), content));
                    line.set(j, "W");
                }
                else if (content.equals("S")) {
                    System.out.println("Startpunkt: " + j + "," + i);
                    startX = j;
                    startY = i;
                }
                else if (content.equals("M")) {
                    System.out.println("MonsterStartPunkt: " + j + "," + i);
                    monsterStartX = j;
                    monsterStartY = i;
                }
            }
        }
    }

    public int getStartX() {
        return startX;
    }

    public int getStartY() {
        return startY;
    }

    public int getMonsterStartX() {
        return this.monsterStartX;
    }

    public int getMonsterStartY() {
        return this.monsterStartY;
    }
	public void setCoin(int x , int y)
    {
        ((ArrayList)this.playground.get(y)).set(x,"C");
    }
    public void addMonster(MonsterData m) {
        //                System.out.println("add Monster: " + m.getName() + ":" + m.getX() + "|" + m.getY());
        monsters.add(m);
    }

    public void addHero(HeroData h) {
        //                System.out.println("add Hero: " + h.getName() + ":" + h.getX() + "|" + h.getY());
        heros.add(h);
    }
    public void removeHero(HeroData h)
    {
        heros.remove(h);
    }


    public void deregisterCharacter(String name) {
        //jl
      	System.out.println("entering deregister Character");
      	//jle
        Iterator i = heros.iterator();
        HeroData h;
        while (i.hasNext()) {
            h = (HeroData)i.next();
            if (h.getName().equals(name)) {
            	//jl
            	System.out.println("deregister Character "+h.getName());
            	//jle
                i.remove();
            }
        }
        i = monsters.iterator();
        MonsterData m;
        while (i.hasNext()) {
            m = (MonsterData)i.next();
            if (m.getName().equals(name))
                i.remove();
        }
    }

    public void setDirection(String name, String direction) {
        Iterator i = heros.iterator();
        HeroData h;
        while (i.hasNext()) {
            h = (HeroData)i.next();
            if (h.getName().equals(name)) {
                h.setDirection(direction);
                return;
            }
        }
        i = monsters.iterator();
        MonsterData m;
        while (i.hasNext()) {
            m = (MonsterData)i.next();
            if (m.getName().equals(name))
                m.setDirection(direction);
            return;
        }
    }

    public ArrayList getPlayground() {
        return this.playground;
    }

    public ArrayList getHeros() {
        return heros;
    }

    public ArrayList getExits() {
        return exits;
    }

    public ArrayList getMonsters() {
        return monsters;
    }

    public void addGUI(String name) {
        System.out.println("add GUI " + name);
        registeredGUIs.add(name);
    }

    public void removeGUI(String name) {
        System.out.println("remove GUI " + name);
        if (registeredGUIs.remove(name)) {
            System.out.println("GUI " + name + "successfully removed!");
        }
        else
            System.out.println("Error: GUI not found in List!");
    }

    public void updateExits(Koordinate koord1, String name, Koordinate koord2) {
        Iterator i = this.exits.iterator();
        while (i.hasNext()) {
            ExitData e = (ExitData)i.next();
            if (e.getKoordinate().equals(koord1)) {
                closeOldConnection(e);
                e.setConnectedField(name);
                e.setConnectedKoord(koord2);
                ((ArrayList)playground.get(koord1.getY())).set(koord1.getX(), e.getContent());
            }
        }
    }

    public void updateExits(Koordinate koordl, int value) {
        Iterator i = this.exits.iterator();
        while (i.hasNext()) {
            ExitData e = (ExitData)i.next();
            if (e.getKoordinate().equals(koordl)) {
                if (value != ExitData.UNCONNECT_NR)
                    this.closeOldConnection(e);
                e.setConnectedField(null);
                e.setConnectedKoord(null);
                e.setContent((String)((ArrayList)playground.get(koordl.getY())).get(koordl.getY()));
                ((ArrayList)playground.get(koordl.getY())).set(koordl.getY(), "W");
            }
        }
    }

    private void closeOldConnection(ExitData e) {
        if (e.isConnected()) {
            //lse die Verbindung zum zweiten Brett
            try {
                System.out.println("lse alte Verbindung mit " + e.getConnectedField() + " Koordinaten: " +
                    e.getConnectedKoord());
                ConnectExit ce = new ConnectExit(e.getConnectedKoord(), "not connected", new Koordinate(-1, -1));
                ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
                AID aid = new AID();
                aid.setName(e.getConnectedField());
                reply.addReceiver(aid);
                reply.setLanguage("connectWith");
                reply.setContentObject(ce);
                send(reply);
            }
            catch (IOException f) {
                f.printStackTrace();
            }
        }
    }

    public ArrayList getRegisteredGUIs() {
        return registeredGUIs;
    }
}
