package pacman.playground;

import java.io.IOException;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.UnreadableException;
import pacman.data.HeroData;
import pacman.data.MonsterData;
import pacman.data.PlaygroundData;
import pacman.data.RegisterCharacter;
import pacman.data.ConnectExit;
import pacman.data.Koordinate;
import pacman.data.ExitData;

/**
 * <p>berschrift: </p> <p>Beschreibung: </p> <p>Copyright: Copyright (c) 2002</p> <p>Organisation: </p>
 * @author unbekannt
 * @version 1.0
 */
public class PlaygroundRequestBehaviour extends SimpleBehaviour {
    public PlaygroundRequestBehaviour(Agent parent) {
        super(parent);
    }

    public void action() {
        ACLMessage msg;
        // receive a new message
        msg = myAgent.receive();
        if (msg == null) {
            block();
            return;
        }
        else {
            String type = msg.getLanguage();
            if (type.equals("getContent")) {
                try {
                    ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
                    reply.addReceiver(msg.getSender());
                    reply.setLanguage("PlaygroundContent");
                    reply.setContentObject(
                        new PlaygroundData(((PlaygroundAgent)myAgent).getAID(), ((PlaygroundAgent)myAgent).getPlayground(),
                        ((PlaygroundAgent)myAgent).getHeros(), ((PlaygroundAgent)myAgent).getMonsters(),
                        ((PlaygroundAgent)myAgent).getExits()));
                    myAgent.send(reply);
                }
                catch (IOException e) {
                    e.printStackTrace();
                }
            }
            else if (type.equals("registerCharacterToPlayground")) {
                try {
                    RegisterCharacter rd = (RegisterCharacter)msg.getContentObject();
                    Koordinate koord = rd.getKoordinate();
                    //lege Startpunkt fest.
                    int x = 0;
                    int y = 0;
                    if (rd.getType() == RegisterCharacter.HERO) {
                        x = ((PlaygroundAgent)myAgent).getStartX();
                        y = ((PlaygroundAgent)myAgent).getStartY();
                    } else if (rd.getType() == RegisterCharacter.MONSTER) {
                        x = ((PlaygroundAgent)myAgent).getMonsterStartX();
                        y = ((PlaygroundAgent)myAgent).getMonsterStartY();
                    }
                    if (koord != null) {
                        x = koord.getX();
                        y = koord.getY();
                    }
                    if (rd.getType() == RegisterCharacter.HERO)
                        ((PlaygroundAgent)myAgent).addHero(new HeroData(rd.getName(), x, y));
                    else
                        ((PlaygroundAgent)myAgent).addMonster(new MonsterData(rd.getName(), x, y));
                }
                catch (UnreadableException e) {
                    e.printStackTrace();
                }
            }
            else if (type.equals("deregisterCharacterFromPlayground")) {
                ((PlaygroundAgent)myAgent).deregisterCharacter(msg.getSender().getName());
            }
            else if (type.equals("registerGUIToPlayground")) {
                String name = msg.getSender().getName();
                ((PlaygroundAgent)myAgent).addGUI(name);
            }
            else if (type.equals("deregisterGUIFromPlayground")) {
                String name = msg.getSender().getName();
                ((PlaygroundAgent)myAgent).removeGUI(name);
            }
            else if (type.equals("destroy")) {
                ((PlaygroundAgent)myAgent).doDelete();
            }
            else if (type.equals("connectWith")) {
                try {
                    ConnectExit ce = (ConnectExit)msg.getContentObject();
                    Koordinate myKoord = ce.getMyKoordinate();
                    Koordinate connectKoord = ce.getConnectKoordinate();
                    String connectHost = ce.getConnectName();
                    if (connectHost.equals("not connected")) {
                        System.out.println("Ausgang " + myKoord + " wird auf NICHT VERBUNDEN geschaltet");
                        ((PlaygroundAgent)myAgent).updateExits(myKoord,
                            (connectKoord == null) ? ExitData.UNCONNECT : ExitData.UNCONNECT_NR);
                    }
                    else {
                        System.out.println("heie: " + myAgent.getAID().getName());
                        System.out.println("und soll Exit " + myKoord + " verbinden mit: " + connectHost);
                        System.out.println("Exit-Koordinaten dort: " + connectKoord);
                        ((PlaygroundAgent)myAgent).updateExits(myKoord, connectHost, connectKoord);
                    }
                }
                catch (UnreadableException e) { e.printStackTrace(); }
            }
            else if (type.equals("setDirection")) {
                ((PlaygroundAgent)myAgent).setDirection(msg.getSender().getName(), (String)msg.getContent());
                //                                System.out.println("Character "+msg.getSender().getName()+"
                // will nach "+(String)msg.getContent()+" laufen");
            }
            else {
                System.out.println("Language: " + type + " " + msg.getSender().getName());
                // ((PlaygroundAgent)myAgent).addMonster(new
                // Monster(msg.getSender().getName(),((PlaygroundAgent)myAgent).getStartX(),((PlaygroundAgent)myAgent).getStartY()));
                System.out.println("Habe unbekannte Nachricht erhalten");
            }
        }
    }

    public boolean done() {
        return false;
    }
}
