package pacman.playground;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.lang.acl.ACLMessage;
import pacman.data.HeroData;
import pacman.data.MoveData;
import pacman.data.MonsterData;
import pacman.data.PlaygroundData;
import jade.core.behaviours.WakerBehaviour;
import pacman.data.ExitData;

/**
 * <p>berschrift: </p> <p>Beschreibung: </p> <p>Copyright: Copyright (c) 2002</p> <p>Organisation: </p>
 * @author unbekannt
 * @version 1.0
 */
public class RefreshBehaviour extends WakerBehaviour {
	// 2 Sekunden, bis Coins wieder hergestellt werden
    private static final long COIN_INTERVALL = 20000;

   public RefreshBehaviour(Agent parent, long timeout) {
      super(parent, timeout);
   }

   protected void handleElapsedTimeout() {
      //1. Bewege alle Agenten (Monster und Helden)
      moveCharacter();
      //2. Pr?fe auf Kollision der Helden mit den Monstern
      checkCollisions();
      //3. Aktualisiere Punktst?nde der Helden
      sendPoints();
      //4. schicke Spielbrett an alle registrierten Charaktere
      sendPlaygroundData();
      //5. zeige Spielfeld auf dem Bildschirm an
      //printPlayground();
      myAgent.addBehaviour(new RefreshBehaviour(myAgent, 1000));
   }

   private void sendPlaygroundData() {
      PlaygroundData pd;
      Iterator i = ((PlaygroundAgent)myAgent).getHeros().iterator();
      HeroData h;
      ACLMessage reply;
      AID aid;
      while (i.hasNext()) {
         h = (HeroData)i.next();
         try {
            pd = new PlaygroundData(((PlaygroundAgent)myAgent).getAID(),
                                    ((PlaygroundAgent)myAgent).getPlayground(),
                                    ((PlaygroundAgent)myAgent).getHeros(),
                                    ((PlaygroundAgent)myAgent).getMonsters(),
                                    ((PlaygroundAgent)myAgent).getExits());
            reply = new ACLMessage(ACLMessage.INFORM);
            aid = new AID();
            aid.setName(h.getName());
            reply.addReceiver(aid);
            reply.setLanguage("PlaygroundContent");
            reply.setContentObject(pd);
            myAgent.send(reply);
         }
         catch (IOException e) {
            e.printStackTrace();
         }
      }
      i = ((PlaygroundAgent)myAgent).getMonsters().iterator();
      MonsterData m;
      while (i.hasNext()) {
         m = (MonsterData)i.next();
         try {
            pd = new PlaygroundData(((PlaygroundAgent)myAgent).getAID(),
                                    ((PlaygroundAgent)myAgent).getPlayground(),
                                    ((PlaygroundAgent)myAgent).getHeros(),
                                    ((PlaygroundAgent)myAgent).getMonsters(),
                                    ((PlaygroundAgent)myAgent).getExits());
            reply = new ACLMessage(ACLMessage.INFORM);
            aid = new AID();
            aid.setName(m.getName());
            reply.addReceiver(aid);
            reply.setLanguage("PlaygroundContent");
            reply.setContentObject(pd);
            myAgent.send(reply);
         }
         catch (IOException e) {
            e.printStackTrace();
         }
      }
      i = ((PlaygroundAgent)myAgent).getRegisteredGUIs().iterator();
      String gui;
      while (i.hasNext()) {
         gui = (String)i.next();
         try {
            pd = new PlaygroundData(((PlaygroundAgent)myAgent).getAID(),
                                    ((PlaygroundAgent)myAgent).getPlayground(),
                                    ((PlaygroundAgent)myAgent).getHeros(),
                                    ((PlaygroundAgent)myAgent).getMonsters(),
                                    ((PlaygroundAgent)myAgent).getExits());
            reply = new ACLMessage(ACLMessage.INFORM);
            aid = new AID();
            aid.setName(gui);
            reply.addReceiver(aid);
            reply.setLanguage("PlaygroundContent");
            reply.setContentObject(pd);
            myAgent.send(reply);
         }
         catch (IOException e) {
            e.printStackTrace();
         }
      }
   }

   private void moveCharacter() {
      ArrayList playground = ((PlaygroundAgent)myAgent).getPlayground();
      //bewege alle Helden
      Iterator i = ((PlaygroundAgent)myAgent).getHeros().iterator();
      HeroData h;
      String direction;
      String newField;
      int x, y;
      while (i.hasNext()) {
         boolean migrated = false;
         h = (HeroData)i.next();
         direction = h.getDirection();
         x = h.getX();
         y = h.getY();
         System.out.println("t9");
         ExitData exit = openExit(x, y);
         if (exit != null) {
            if ((x == 0
                 && direction.equals("W"))
                  || (y == 0 && direction.equals("N")) ||
                  (y == (playground.size() - 1) && direction.equals("S")) ||
                  (x == (((ArrayList)playground.get(0)).size() - 1)
                   && direction.equals("E"))) {
               //migriere Character
               System.out.println("t8");
               try {
                  migrated = true;
                  ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
                  AID aid = new AID();
                  aid.setName(h.getName());
                  reply.addReceiver(aid);
                  MoveData moveObject = new MoveData(exit.getConnectedField(),
                                                     exit.getConnectedKoord());
                  reply.setLanguage("moveToNewField");
                  reply.setContentObject(moveObject);
                  myAgent.send(reply);
                  //schmeie Held aus eigener Liste
                  //jl: gibt so Probleme... testweise wieder aktiviert; wieder aktiviert
                  i.remove();
               }
               catch (IOException e) { e.printStackTrace(); }
            }
         }
         System.out.println("t7");
         if (!migrated) {
            System.out.println("t6");
            if (direction.equals("N"))
               y--;
            else if (direction.equals("W"))
               x--;
            else if (direction.equals("S"))
               y++;
            else if (direction.equals("E"))
               x++;
            newField = ((String)((ArrayList)playground.get(y)).get(x));
            if (newField.equals("C")
                  || newField.equals("P") || newField.equals("S")|| newField.equals("M")) {
                  //jl: auch "M", da man sonst nicht als Held ber Monsterfeld gehen kann
               //Das neue Feld ist ein begehbares Feld
               h.setX(x);
               h.setY(y);
            }
            else {
               //das neue Feld w?re eine Wand
               h.setDirection("");
            }
         }
      }
      //bewege alle Monster
      i = ((PlaygroundAgent)myAgent).getMonsters().iterator();
      MonsterData m;
      while (i.hasNext()) {
         boolean migrated = false;
         m = (MonsterData)i.next();
         direction = m.getDirection();
         x = m.getX();
         y = m.getY();
         System.out.println("t4 "+direction+" "+x+" "+y);
         ExitData exit = openExit(x, y);
         if (exit != null) {
            System.out.println("t2");
            if ((x == 0
                 && direction.equals("W"))
                  || (y == 0 && direction.equals("N")) ||
                  (y == (playground.size() - 1) && direction.equals("S")) ||
                  (x == (((ArrayList)playground.get(0)).size() - 1)
                   && direction.equals("E"))) {
               //migriere Character
               System.out.println("t3");
               try {
                  migrated = true;
                  ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
                  AID aid = new AID();
                  aid.setName(m.getName());
                  reply.addReceiver(aid);
                  MoveData moveObject = new MoveData(exit.getConnectedField(),
                                                     exit.getConnectedKoord());
                  reply.setLanguage("moveToNewField");
                  reply.setContentObject(moveObject);
                  myAgent.send(reply);
                  //schmeie Monster aus eigener Liste
                  i.remove();
               }
               catch (IOException e) { e.printStackTrace(); }
            }
         }
         System.out.println("t1");
         if (!migrated) {
            if (direction.equals("N"))
               y--;
            else if (direction.equals("W"))
               x--;
            else if (direction.equals("S"))
               y++;
            else if (direction.equals("E"))
               x++;
            newField = ((String)((ArrayList)playground.get(y)).get(x));
            //jl: Monster starten im Moment im Feld S, daher hier aufgenommen
            System.out.println("monster "+direction+" "+newField+" "+x+" "+y);
            if (newField.equals("C")
                  || newField.equals("P")
                  || newField.equals("M") || newField.equals("S")) {
               //Das neue Feld ist ein begehbares Feld
               m.setX(x);
               m.setY(y);
               System.out.println("monster begehbar");
            }
            else {
               //das neue Feld wre eine Wand
               m.setDirection("");
            }
         }
      }
   }

   private ExitData openExit(int x, int y) {
      Iterator i = ((PlaygroundAgent)myAgent).getExits().iterator();
      ExitData e;
      while (i.hasNext()) {
         e = (ExitData)i.next();
         if (e.isConnected()
               && x == e.getKoordinate().getX()
               && y == e.getKoordinate().getY())
            return e;
      }
      return null;
   }

   private void checkCollisions() {
      //iteriere ber die Helden, ob sie evtl. auf bzw. unter
      //einem Monster stehen (oder direkt voreinander!)
      //Wenn ja: Manahmen einleiten
      Iterator i = ((PlaygroundAgent)myAgent).getHeros().iterator();
      Iterator j;
      HeroData h;
      MonsterData m;
      while (i.hasNext()) {
         h = (HeroData)i.next();
         j = ((PlaygroundAgent)myAgent).getMonsters().iterator();
         while (j.hasNext()) {
            m = (MonsterData)j.next();
            if (((h.getX() == m.getX()) && (h.getY() == m.getY())) ||
				((h.getX() == m.getX()) && (( h.getY() == (m.getY()+1)) || (h.getY() == (m.getY()-1)))) ||
                (((h.getX() == (m.getX()+1)) || (h.getX() == (m.getX()-1))) && (h.getY() == m.getY())))
				{
               //lsche Held aus Liste
               i.remove();
               //gebe Anweisung zum Agenten ein Leben zu reduzieren.
               ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
               AID aid = new AID();
               aid.setName(h.getName());
               reply.addReceiver(aid);
               reply.setLanguage("decreaseLife");
               myAgent.send(reply);
            }
         }
      }
   }

   private void sendPoints() {
      //1. prfe, welcher der Helden unter einem "C"-Feld steht.
      //2. "C" in "P" umwandeln
      //3. Helden eine Nachricht schicken
      ArrayList playground = ((PlaygroundAgent)myAgent).getPlayground();
      Iterator i = ((PlaygroundAgent)myAgent).getHeros().iterator();
      HeroData h;
      int x;
      int y;
      while (i.hasNext()) {
         h = (HeroData)i.next();
         x = h.getX();
         y = h.getY();
         if (((String)((ArrayList)playground.get(y)).get(x)).equals("C")) {
            //Held ist auf einem Coin - Feld
            //1. "C" in "P" umwandeln
            ((ArrayList)playground.get(y)).set(x, "P");
            //2. Helden benachrichtigen
            ACLMessage reply = new ACLMessage(ACLMessage.INFORM);
            AID aid = new AID();
            aid.setName(h.getName());
            reply.addReceiver(aid);
            reply.setLanguage("addCreditPoint");
            myAgent.send(reply);
            //CoinBehaviour anweisen, nach x Sekunden Coin neu zu setzen
            myAgent.addBehaviour(new CoinBehaviour(myAgent,this.COIN_INTERVALL,x,y));
         }
      }
   }

   private void printPlayground() {
      //stellt Spielfeld grafisch dar
      //kopiere Spielfeld
      ArrayList tmpPlayground = new ArrayList();
      ArrayList tmpa = new ArrayList();
      Iterator a = ((PlaygroundAgent)myAgent).getPlayground().iterator();
      Iterator b;
      while (a.hasNext()) {
         b = ((ArrayList)a.next()).iterator();
         tmpa = new ArrayList();
         while (b.hasNext()) {
            tmpa.add((String)b.next());
         }
         tmpPlayground.add(tmpa);
      }
      //fge Helden zum Spielfeld hinzu
      Iterator hi = ((PlaygroundAgent)myAgent).getHeros().iterator();
      HeroData h;
      while (hi.hasNext()) {
         h = (HeroData)hi.next();
         ((ArrayList)tmpPlayground.get(h.getY())).set(h.getX(), "H");
      }
      //jl
      //fge Monster zum Spielfeld hinzu
      Iterator mi = ((PlaygroundAgent)myAgent).getMonsters().iterator();
      MonsterData m;
      while (mi.hasNext()) {
         m = (MonsterData)mi.next();
         ((ArrayList)tmpPlayground.get(m.getY())).set(m.getX(), "M");
      }
      //jle
      Iterator i = tmpPlayground.iterator();
      Iterator j;
      StringBuffer sb = new StringBuffer();
      while (i.hasNext()) {
         j = ((ArrayList)i.next()).iterator();
         while (j.hasNext()) {
            sb.append((String)j.next());
         }
         sb.append("\n");
      }
      System.out.println(sb.toString());
   }
}
