/* Generated by Together */

package pacman.startup;

import javax.swing.UIManager;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JButton;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import jade.core.Runtime;
import jade.wrapper.*;
import jade.core.Profile;
import jade.core.ProfileImpl;
import javax.swing.JOptionPane;
import java.io.IOException;
import pacman.control.DataManager;

public class Startup extends JFrame {
    private JButton mainContainerButton = new JButton("new MainContainer");
    private JButton controlButton = new JButton("new ControlAgent");
    private JButton controllerButton = new JButton("new ControllerAgent");
    private JButton guiButton = new JButton("new GUIAgent");

    public Startup() {
        initGUI();
        pack();
    }

    public static void main(String[] argv) {
        Startup frame = new Startup();
        //Center the frame on screen
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        frameSize.height = ((frameSize.height > screenSize.height) ? screenSize.height : frameSize.height);
        frameSize.width = ((frameSize.width > screenSize.width) ? screenSize.width : frameSize.width);
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
        // set up system Look&Feel
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    /** This method is called from within the constructor to initialize the form. */
    private void initGUI() {
        controlButton.setToolTipText("start a new ControlAgent");
        controlButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) { startControlAgent(); }
            });
        controlButton.setEnabled(true);
        mainContainerButton.setToolTipText("start a new MainContainer");
        mainContainerButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) { startMainContainer(); }
            });
        controllerButton.setEnabled(true);
        controllerButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) { startControllerAgent(); }
            });
        guiButton.setEnabled(true);
        guiButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) { startGUIAgent(); }
            });
        getContentPane().setLayout(new java.awt.GridLayout(4, 1));
        getContentPane().add(mainContainerButton);
        getContentPane().add(controlButton);
        getContentPane().add(controllerButton);
        getContentPane().add(guiButton);
        // set title
        setTitle("Startup-Tool");
        setBounds(new java.awt.Rectangle(0, 0, 197, 58));
        addWindowListener(
            new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent evt) {
                    exit();
                }
            });
    }

    private void startControlAgent() {
        System.out.println("start ControlAgent");
        String name = JOptionPane.showInputDialog(this, "Enter Agent name", "Question", JOptionPane.QUESTION_MESSAGE);
        Object reference = new Object();
        Object args[] = new Object[1];
        args[0] = reference;
        try {
            AgentController agentController = DataManager.getInstance().getNewContainer(this).createNewAgent(name, "pacman.control.ControlAgent", args);
            agentController.start();
        }
        catch (StaleProxyException e) { }
        catch (ControllerException e) { }
    }

    public void startMainContainer() {
        System.out.println("start a new MainContainer");
        try {
            Process p = java.lang.Runtime.getRuntime().exec("java jade.Boot -gui");
            this.guiButton.setEnabled(true);
            this.controlButton.setEnabled(true);
            this.controllerButton.setEnabled(true);

        }
        catch (IOException e) { e.printStackTrace(); }
    }

    public void startControllerAgent() {
         String name = JOptionPane.showInputDialog(this, "Enter Agent name", "Question", JOptionPane.QUESTION_MESSAGE);
       Object reference = new Object();
        Object args[] = new Object[1];
        args[0] = reference;
        try {
            AgentController agentController = DataManager.getInstance().getNewContainer(this).createNewAgent(name, "pacman.controller.ControllerAgent", args);
            agentController.start();
        }
        catch (StaleProxyException e) { }
        catch (ControllerException e) { }
    }

    public void startGUIAgent() {
         String name = JOptionPane.showInputDialog(this, "Enter Agent name", "Question", JOptionPane.QUESTION_MESSAGE);
       Object reference = new Object();
        Object args[] = new Object[1];
        args[0] = reference;
        try {
            AgentController agentController = DataManager.getInstance().getNewContainer(this).createNewAgent(name, "pacman.gui.GUIAgent", args);
            agentController.start();
        }
        catch (StaleProxyException e) { }
        catch (ControllerException e) { }
    }

    public void exit() {
        System.exit(0);
    }
}
